/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEd
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 ' As a special exception, Arnel A. Borja gives unlimited permission to copy, 
 ' distribute and modify the files that are the output of this program, and to 
 ' copy and distribute the resulting files under terms of your choice.  You need 
 ' not follow the terms of the GNU General Public License when using or 
 ' distributing such files, even though portions of the text of the program 
 ' appear in them.  The GNU General Public License (GPL) does govern all other 
 ' use of the material that constitutes the program.
 '
 ' This special exception to the GPL applies to versions of the program released 
 ' by Arnel A. Borja.  When you make and distribute a modified version of the 
 ' program, you may extend this special exception to the GPL to apply to your 
 ' modified version as well.
 '
 '/


#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "Fonts.bi"


Sub LoadFonts( _
	ByVal hWin As HWND _
	)

	Dim lf As LOGFONT
	Dim hDC As HDC = GetDC( hWin )

	' Set defaults
	With lf
		.lfWidth		= 0
		.lfWeight	= FW_BOLD
	End With

	' Create font for Welcome/Finish/Failed message static controls
	With lf
		.lfFaceName	= GetTranslateString( "1", "Arial" )
		.lfHeight	= -MulDiv( 11, GetDeviceCaps( hDC, LOGPIXELSY ), 72 )
	End With
	WelcomeMsgFont = CreateFontIndirect( @lf )

	' Create font for Header Title static controls
	With lf
		.lfFaceName	= "MSDialog"
		.lfHeight	= -MulDiv( 8, GetDeviceCaps( hDC, LOGPIXELSY ), 72 )
	End With
	HeaderTitleFont = CreateFontIndirect( @lf )

	ReleaseDC( hWin, hDC )

End Sub


Sub FreeFonts( _
	)

	If WelcomeMsgFont Then DeleteObject( WelcomeMsgFont )
	If HeaderTitleFont Then DeleteObject( HeaderTitleFont )

End Sub

