/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEd
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 ' As a special exception, Arnel A. Borja gives unlimited permission to copy, 
 ' distribute and modify the files that are the output of this program, and to 
 ' copy and distribute the resulting files under terms of your choice.  You need 
 ' not follow the terms of the GNU General Public License when using or 
 ' distributing such files, even though portions of the text of the program 
 ' appear in them.  The GNU General Public License (GPL) does govern all other 
 ' use of the material that constitutes the program.
 '
 ' This special exception to the GPL applies to versions of the program released 
 ' by Arnel A. Borja.  When you make and distribute a modified version of the 
 ' program, you may extend this special exception to the GPL to apply to your 
 ' modified version as well.
 '
 '/


#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "Settings.bi"
#Include Once "Fonts.bi"
#Include Once "Help.bi"
#Include Once "Header.bi"
#Include Once "Resource.bi"


Function HeaderDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			' Change Header Title static controls font
			SendDlgItemMessage( hWin, IDC_STCHEADERTITLE, WM_SETFONT, Cast( WPARAM, HeaderTitleFont), MAKELPARAM( TRUE, 0 ) )

			' Set values of title and subtitle
			If lParam Then
				SetDlgItemText( hWin, IDC_STCHEADERTITLE, Cast( HeaderInfo Ptr, lParam )->Title ) 
				SetDlgItemText( hWin, IDC_STCHEADERSUBTITLE, Cast( HeaderInfo Ptr, lParam )->Subtitle ) 
			End If
			'
		Case WM_CTLCOLORDLG
			' Change Header Title and Subtitle background color
			Return Cast( Integer, GetStockObject( WHITE_BRUSH ) )
			'
		Case WM_CTLCOLORSTATIC
			' Change Header Title and Subtitle background color
			SetBkMode( Cast( HDC, wParam ), TRANSPARENT )
			Return Cast( Integer, GetStockObject( WHITE_BRUSH ) )
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return DefWindowProc( hWin, uMsg, wParam, lParam )
			'
	End Select

	Return TRUE

End Function


Sub AddHeaderToPage( _
	ByVal PageHwnd As HWND, _
	ByRef Title As Const String, _
	ByRef Subtitle As Const String _
	)

	Dim HeaderInfo As HeaderInfo = ( _
		StrPtr( Title ), _
		StrPtr( Subtitle ) _
		)

	CreateDialogParam( hInstance, MAKEINTRESOURCE( IDD_DLGHEADER ), PageHwnd, @HeaderDialogProc, Cast( LPARAM, @HeaderInfo ) )

End Sub

