
' Messages to MasmEd's main window
#Define MEAIM_GETHANDLES					WM_USER+50					' Returns a poiner to a struct containing all useful handles. See ADDINHANDLES structure below.
#Define MEAIM_GETPROCS						WM_USER+51					' Returns a poiner to a struct containing some procs in MasmEd. See ADDINPROCS structure below.
#Define MEAIM_GETDATA						WM_USER+52					' Returns a poiner to a struct comtaining data pointers. See ADDINDATA structure below.
#Define MEAIM_GETMENUID						WM_USER+53					' Returns a free menu id. If you need more than one, wParam contains the number of id's to reserve.

' Messages sendt to addins
#Define MEAIM_ADDINSLOADED					WM_USER+100					' This message is sendt to the addins after all addins are loaded. hWin=Main window, wParam=0, lParam=0
#Define MEAIM_COMMAND						WM_USER+101					' This message is sendt to the addins when user makes a menu selection or clicks a toolbar button. hWin=Main window, wParam and lParam as for WM_COMMAND
#Define MEAIM_CLOSE							WM_USER+102					' MasmEd requests closing. Return TRUE to prevent MasmEd from closing. hWin=Main window, wParam and lParam as for WM_CLOSE
#Define MEAIM_DESTROY						WM_USER+103					' MasmEd is about to be destroyed. Now is the time to free memory and resources that your addin allocated. Always return FALSE. hWin=Main window, wParam and lParam as for WM_DESTROY
#Define MEAIM_MENUUPDATE					WM_USER+104					' MasmEd has updated menues. Now is the time to add menu items. Always return FALSE. hWin=Main window, wParam=hMnu, lParam=hContextMnu. NOTE: This command can be sendt more than once. Do not allocate MenuID's here
#Define MEAIM_NEWFILE						WM_USER+105					' A new file is about to be created. Return TRUE to prevent MasmEd from creating the file. hWin=Main window, wParam=IDC_RAE or IDC_RES, lParam=lpFileName
#Define MEAIM_FILEOPEN						WM_USER+106					' A file is about to be opened. Return TRUE to prevent MasmEd from opening the file. hWin=Main window, wParam=IDC_RAE, IDC_RES, IDC_HEX, IDC_EXECUTE, IDC_USER or IDC_MES, lParam=lpFileName
#Define MEAIM_FILEOPENED					WM_USER+107					' A file has ben opened.. Always return FALSE. hWin=Main window, wParam=IDC_RAE, IDC_RES, IDC_HEX, IDC_EXECUTE or IDC_MES, lParam=lpFileName
#Define MEAIM_FILECLOSE						WM_USER+108					' A file is about to be closed.. Return TRUE to prevent MasmEd from closing the file. hWin=Editor window, wParam=IDC_RAE, IDC_RES, IDC_HEX or IDC_USER, lParam=lpFileName
#Define MEAIM_FILECLOSED					WM_USER+109					' A file has been closed.. Always return FALSE. hWin=Editor window, wParam=IDC_RAE, IDC_RES or IDC_HEX, lParam=lpFileName
#Define MEAIM_FILESAVE						WM_USER+110					' A file is about to be saved. Return TRUE to prevent MasmEd from saving the file. hWin=Editor window, wParam=IDC_RAE, IDC_RES, IDC_HEX or IDC_USER, lParam=lpFileName
#Define MEAIM_FILESAVEAS					WM_USER+111					' A file is about to be saved with a new name. Return TRUE to prevent MasmEd from saving the file. hWin=Editor window, wParam=IDC_RAE, IDC_RES, IDC_HEX or IDC_USER, lParam=lpFileName
#Define MEAIM_FILESAVEED					WM_USER+112					' A file has been saved. Always return FALSE. hWin=Editor window, wParam=IDC_RAE, IDC_RES, IDC_HEX or IDC_USER, lParam=lpFileName
#Define MEAIM_GETMODIFY						WM_USER+113					' MasmEd requests if a file is changed. Return TRUE if it is your file and it has changed. hWin=Editor window, wParam=IDC_USER, lParam=lpFileName
#Define MEAIM_MAKEBEGIN						WM_USER+114					' MasmEd starts a make process. Return TRUE to prevent MasmEd from running the make process. hWin=Main window, wParam=IDM_MAKE_COMPILE, IDM_MAKE_ASSEMBLE, IDM_MAKE_LINK, IDM_MAKE_BUILD, IDM_MAKE_RUN or IDM_MAKE_GO, lParam=Main file
#Define MEAIM_MAKEDONE						WM_USER+115					' MasmEd finished the make process. Always return FALSE. hWin=Main window, wParam=IDM_MAKE_COMPILE, IDM_MAKE_ASSEMBLE, IDM_MAKE_LINK, IDM_MAKE_BUILD, IDM_MAKE_RUN or IDM_MAKE_GO, lParam=Main file

' HOOK flags returned in hook1 of HOOK structure
#Define MEAIH_ADDINSLOADED					&H0001
#Define MEAIH_COMMAND						&H0002
#Define MEAIH_CLOSE							&H0004
#Define MEAIH_DESTROY						&H0008
#Define MEAIH_MENUUPDATE					&H0010
#Define MEAIH_NEWFILE						&H0020
#Define MEAIH_FILEOPEN						&H0040
#Define MEAIH_FILEOPENED					&H0080
#Define MEAIH_FILECLOSE						&H0100
#Define MEAIH_FILECLOSED					&H0200
#Define MEAIH_FILESAVE						&H0400
#Define MEAIH_FILESAVEAS					&H0800
#Define MEAIH_FILESAVEED					&H1000
#Define MEAIH_GETMODIFY						&H2000
#Define MEAIH_MAKEBEGIN						&H4000
#Define MEAIH_MAKEDONE						&H8000

Type MEHOOK
	hook1											As DWORD						' Combinations of MEAIH_ flags
	hook2											As DWORD						' Not used must be zero
	hook3											As DWORD						' Not used must be zero
	hook4											As DWORD						' Not used must be zero
End Type

Type MEADDINHANDLES
	hWnd											As HWND						' Handle of main window.
	hClient										As HWND						' Handle to window shown if no files are open.
	hREd											As HWND						' Handle to current selected editor.
	hTab											As HWND						' Handle to tab select tool.
	hBtn											As HWND						' Handle to close button.
	hFind											As HWND						' Handle to Find / Replace dialog.
	hTbr											As HWND						' Handle to toolbar.
	hShp											As HWND						' Handle to box surrounding toolbar.
	hStc											As HWND						' Container for Make type combobox
	hCbo											As HWND						' Handle to Make type combobox.
	hCCLB											As HWND						' Handle to code complete listbox.
	hCCTT											As HWND						' Handle to code tooltip.
	hRes											As HWND						' Handle to resource editor container.
	hResEd										As HWND						' Handle to resource editor work area.
	hOut											As HWND						' Handle to output window (RAEdit)
	hImmOut										As HWND						' Handle to immediate window (RAEdit)
	hTabOut										As HWND						' Handle to tab selectin output or immediate.
	hBrowse										As HWND						' Handle to file browser.
	hProperty									As HWND						' Handle to code property.
	hSbr											As HWND						' Handle to status bar.
	hDbgReg										As HWND						' Handle to debug register window (RAEdit).
	hDbgWatch									As HWND						' Handle to debug watch window (RAEdit).
	hTabDbg										As HWND						' Handle to tab selecting register or watch window.
	hDbgTip										As HWND						' Handle to debug tooltip.
	hInstance									As HINSTANCE				' MasmEd's instance.
	hAccel										As HACCEL					' Handle to accelerator table.
	hMnu											As HMENU						' Handle to MasmEd's menu.
	hContextMnu									As HMENU						' Handle to MasmEd's context menu.
	hVSplitCur									As HCURSOR					' Handle to cursor.
	hHSplitCur									As HCURSOR					' Handle to cursor.
	hFont											As HFONT						' RAEdit font.
	hIFont										As HFONT						' RAEdit italics font.
	hLnrFont										As HFONT						' RAEdit line number font.
	hImlTbr										As HIMAGELIST				' Handle to toolbar imagelist.
	hImlTbrGray									As HIMAGELIST				' Handle to toolbar grayed imagelist.
	hMnuIml										As HIMAGELIST				' Handle to menu imagelist.
	hBrBack										As HBRUSH					' Handle to background brush.
	hMenuBrushA									As HBRUSH					' Handle to menu background brush.
	hMenuBrushB									As HBRUSH					' Handle to menu background brush.
	hMnuFont										As HFONT						' Handle to menu font.
	hReg											As HKEY						' Handle to MasmEd's registry key.
	hDbgFpu										As HWND						' Handle to debug FPU window (RAEdit).
	hDbgMMX										As HWND						' Handle to debug MMX window (RAEdit).
	hTabPbr										As HWND						' Handle to File / Project tab
	hPbr											As HWND						' Handle to project browser
End Type

Type MEMAKEOPT
	szType										As ZString * 32			' Build type
	szCompileRC									As ZString * 128			' Compile resource command
	szAssemble									As ZString * 128			' Assemble command
	szLink										As ZString * 128			' Link command
	OutpuType									As DWORD						' Output filetype
End Type

Type MEADDINDATA
	AppPath										As ZString * MAX_PATH	' Path to where MasmEd.exe was started.
	FileName										As ZString * MAX_PATH	' Filename of current selected file.
	MainFile										As ZString * MAX_PATH	' Filename of main file, if any.
	DbgFileName									As ZString * MAX_PATH	' Fileneme of debugged file, if any.
	findbuff										As ZString * 256			' Find text.
	replacebuff									As ZString * 256			' Replace text.
	szInitFolder								As ZString * MAX_PATH	' Initial folder.
	szSessionFile								As ZString * MAX_PATH	' Current session file, if any.
	PathBin										As ZString * MAX_PATH	' Path to assembler, linker and resource compiler.
	PathInc										As ZString * MAX_PATH	' Path to include files.
	PathLib										As ZString * MAX_PATH	' Path to libraries.
	makeopt(16)									As MEMAKEOPT				' Make options
	nBuildOpt									As DWORD						' Current make option
	ver											As DWORD						' MasmEd version
	lpCharTab									As DWORD						' Pointer to RAEdit character table
	lpszVersion									As DWORD						' Pointer to version string
	fProject										As DWORD						' TRUE if there is a project
End Type

Type MEADDINPROCS
	OpenEditFile								As DWORD						' Opens a file. lpFileName:DWORD,fType:DWORD
	OutputSelect								As DWORD						' Selects Output or Immediate. nSel:DWORD (0 or 1)
	OutputShow									As DWORD						' Shows or hides the selected output. fShow:DWORD (TRUE or FALSE)
	OutputString								As DWORD						' Outputs a string to selected output. lpString:DWORD
	OutputClear									As DWORD						' Clears the selected output.
	TabToolAdd									As DWORD						' Adds a new tab. hWin:HWND,lpFileName:DWORD
	TabToolActivate							As DWORD						' Activates the current tab.
	TabToolGetMem								As DWORD						' Gets a pointer to TABMEM. hWin:DWORD
	UpdateFileTime								As DWORD						' Updates the filetime. lpTABMEM:DWORD
	TabToolSetChanged							As DWORD						' Sets the tabs changed state. hWin:DWORD,fChanged:DWORD (TRUE or FALSE)
	UpdateFileName								As DWORD						' Changes the filename for current selected tab. hWin:DWORD,lpFileName:DWORD
	WriteSessionFile							As DWORD						' Saves session file. lpFileName:DWORD
End Type

' #########################################################################

Type METABMEM
	hwnd											As HWND						' Handle of the editor window.
	pid											As DWORD						' Project id
	filename										As ZString * MAX_PATH	' Filename including full path.
	ft												As FILETIME					' Filetime for last write.
	nchange										As DWORD
	fchanged										As DWORD
	fupdate										As DWORD
	fnonotify									As DWORD
End Type

' Edit window ID's
#Define MEIDC_RAE								1011							' Text editor
#Define MEIDC_RES								1012							' Resource editor
#Define MEIDC_HEX								1013							' Hex editor
#Define MEIDC_EXECUTE						1014							' File can be executed. (.com, .bat or .exe)
#Define MEIDC_USER							1015							' User defined editor
#Define MEIDC_MES								1016							' Session file

' MasmEd menu ID's
#Define MEIDM_MENU							10000
#Define MEIDM_FILE							11000
#Define MEIDM_FILE_NEW						10001
#Define MEIDM_FILE_NEW_RES					10007
#Define MEIDM_FILE_OPEN						10002
#Define MEIDM_FILE_OPEN_HEX				10022
#Define MEIDM_FILE_SAVE						10003
#Define MEIDM_FILE_SAVEAS					10004
#Define MEIDM_FILE_SAVEALL					10011
#Define MEIDM_FILE_CLOSE					10010
#Define MEIDM_FILE_CLOSE_ALL				10058
#Define MEIDM_FILE_PAGESETUP				10029
#Define MEIDM_FILE_PRINT					10005
#Define MEIDM_FILE_RECENTFILES			10094
#Define MEIDM_FILE_RECENT_SESSIONS		10095
#Define MEIDM_FILE_EXIT						10006
#Define MEIDM_EDIT							11001
#Define MEIDM_EDIT_UNDO						10101
#Define MEIDM_EDIT_REDO						10102
#Define MEIDM_EDIT_DELETE					10103
#Define MEIDM_EDIT_CUT						10104
#Define MEIDM_EDIT_COPY						10105
#Define MEIDM_EDIT_PASTE					10106
#Define MEIDM_EDIT_SELECTALL				10107
#Define MEIDM_EDIT_FIND						10108
#Define MEIDM_EDIT_FINDNEXT				10110
#Define MEIDM_EDIT_FINDPREV				10111
#Define MEIDM_EDIT_REPLACE					10109
#Define MEIDM_EDIT_GOTO						10091
#Define MEIDM_EDIT_RETURN					10092
#Define MEIDM_EDIT_BLOCK					10060
#Define MEIDM_EDIT_INDENT					10037
#Define MEIDM_EDIT_OUTDENT					10038
#Define MEIDM_EDIT_COMMENT					10035
#Define MEIDM_EDIT_UNCOMMENT				10036
#Define MEIDM_EDIT_BLOCKCONVERT			10096
#Define MEIDM_EDIT_BLOCKUPPER				10097
#Define MEIDM_EDIT_BLOCKLOWER				10098
#Define MEIDM_EDIT_BLOCKTABTOSPC			10099
#Define MEIDM_EDIT_BLOCKSPCTOTAB			10100
#Define MEIDM_EDIT_BLOCKSPCTRIM			10112
#Define MEIDM_EDIT_BLOCKMODE				10061
#Define MEIDM_EDIT_BLOCKINSERT			10062
#Define MEIDM_EDIT_TOGGLEBM				10018
#Define MEIDM_EDIT_NEXTBM					10019
#Define MEIDM_EDIT_PREVBM					10020
#Define MEIDM_EDIT_CLEARBM					10021
#Define MEIDM_EDIT_NEXTERROR				10075
#Define MEIDM_EDIT_CLEARERRORS			10074
#Define MEIDM_FORMAT							11002
#Define MEIDM_FORMAT_LOCK					10012
#Define MEIDM_FORMAT_BACK					10013
#Define MEIDM_FORMAT_FRONT					10014
#Define MEIDM_FORMAT_GRID					10015
#Define MEIDM_FORMAT_SNAP					10016
#Define MEIDM_FORMAT_ALIGN					10017
#Define MEIDM_FORMAT_ALIGN_LEFT			10034
#Define MEIDM_FORMAT_ALIGN_CENTER		10042
#Define MEIDM_FORMAT_ALIGN_RIGHT			10043
#Define MEIDM_FORMAT_ALIGN_TOP			10044
#Define MEIDM_FORMAT_ALIGN_MIDDLE		10045
#Define MEIDM_FORMAT_ALIGN_BOTTOM		10046
#Define MEIDM_FORMAT_SIZE					10033
#Define MEIDM_FORMAT_SIZE_WIDTH			10039
#Define MEIDM_FORMAT_SIZE_HEIGHT			10040
#Define MEIDM_FORMAT_SIZE_BOTH			10041
#Define MEIDM_FORMAT_CENTER				10066
#Define MEIDM_FORMAT_CENTER_HOR			10067
#Define MEIDM_FORMAT_CENTER_VERT			10068
#Define MEIDM_FORMAT_TABINDEX				10069
#Define MEIDM_PROJECT_CREATE				21022
#Define MEIDM_PROJECT_OPEN					10114
#Define MEIDM_PROJECT_CLOSE				10115
#Define MEIDM_VIEW							11003
#Define MEIDM_VIEW_TOOLBAR					10008
#Define MEIDM_VIEW_STATUSBAR				10009
#Define MEIDM_VIEW_OUTPUT					10023
#Define MEIDM_VIEW_FILEBROWSER			10059
#Define MEIDM_VIEW_DIALOG					10065
#Define MEIDM_VIEW_NEXTTAB					10116
#Define MEIDM_VIEW_PREVIOUSTAB			10117
#Define MEIDM_RESOURCE						11004
#Define MEIDM_RESOURCE_DIALOG				10048
#Define MEIDM_RESOURCE_MENU				10049
#Define MEIDM_RESOURCE_ACCEL				10050
#Define MEIDM_RESOURCE_VERINF				10051
#Define MEIDM_RESOURCE_STRING				10054
#Define MEIDM_RESOURCE_MANIFEST			10071
#Define MEIDM_RESOURCE_RCDATA				10072
#Define MEIDM_RESOURCE_TOOLBAR			10073
#Define MEIDM_RESOURCE_LANGUAGE			10064
#Define MEIDM_RESOURCE_INCLUDE			10052
#Define MEIDM_RESOURCE_RESOURCE			10053
#Define MEIDM_RESOURCE_NAME				10055
#Define MEIDM_RESOURCE_EXPORT				10063
#Define MEIDM_RESOURCE_REMOVE				10056
#Define MEIDM_RESOURCE_UNDO				10057
#Define MEIDM_MAKE							11004
#Define MEIDM_MAKE_COMPILE					10024
#Define MEIDM_MAKE_ASSEMBLE				10025
#Define MEIDM_MAKE_LINK						10026
#Define MEIDM_MAKE_BUILD					10090
#Define MEIDM_MAKE_RUN						10027
#Define MEIDM_MAKE_GO						10028
#Define MEIDM_MAKE_MAINFILE				10079
#Define MEIDM_DEBUG							10113
#Define MEIDM_DEBUG_TOGGLE					10082
#Define MEIDM_DEBUG_CLEAR					10083
#Define MEIDM_DEBUG_RUN						10081
#Define MEIDM_DEBUG_BREAK					10089
#Define MEIDM_DEBUG_STOP					10084
#Define MEIDM_DEBUG_INTO					10085
#Define MEIDM_DEBUG_OVER					10086
#Define MEIDM_DEBUG_CARET					10087
#Define MEIDM_DEBUG_NODEBUG				10088
#Define MEIDM_TOOLS							11005
#Define MEIDM_TOOLS_EMPTY					20000
#Define MEIDM_OPTIONS						11006
#Define MEIDM_OPTION_CODE					10030
#Define MEIDM_OPTION_DIALOG				10047
#Define MEIDM_OPTION_PATH					10080
#Define MEIDM_OPTION_BUILD					10070
#Define MEIDM_OPTION_ADDINS				10093
#Define MEIDM_OPTION_TOOLS					10031
#Define MEIDM_OPTION_HELP					10032
#Define MEIDM_OPTION_EXTERNAL				10076
#Define MEIDM_HELP							11007
#Define MEIDM_HELP_ABOUT					10201
#Define MEIDM_HELP_EMPTY					30000

/' This seems not to work properly
#Define MEIDM_MENU							10000
#Define MEIDM_HELPF1							500
#Define MEIDM_FILE							11000
#Define MEIDM_FILE_NEW						10001
#Define MEIDM_FILE_NEW_RES					10007
#Define MEIDM_FILE_OPEN						10002
#Define MEIDM_FILE_OPEN_HEX				10022
#Define MEIDM_FILE_SAVE						10003
#Define MEIDM_FILE_SAVEAS					10004
#Define MEIDM_FILE_SAVEALL					10011
#Define MEIDM_FILE_CLOSE					10010
#Define MEIDM_FILE_CLOSE_ALL				10058
#Define MEIDM_FILE_PAGESETUP				10029
#Define MEIDM_FILE_PRINT					10005
#Define MEIDM_FILE_RECENTFILES			10094
#Define MEIDM_FILE_RECENTSESSIONS		10095
#Define MEIDM_FILE_EXIT						10006

#Define MEIDM_EDIT							11001
#Define MEIDM_EDIT_UNDO						10101
#Define MEIDM_EDIT_REDO						10102
#Define MEIDM_EDIT_DELETE					10103
#Define MEIDM_EDIT_CUT						10104
#Define MEIDM_EDIT_COPY						10105
#Define MEIDM_EDIT_PASTE					10106
#Define MEIDM_EDIT_SELECTALL				10107
#Define MEIDM_EDIT_FIND						10108
#Define MEIDM_EDIT_FINDNEXT				10110
#Define MEIDM_EDIT_FINDPREV				10111
#Define MEIDM_EDIT_REPLACE					10109
#Define MEIDM_EDIT_GOTO						10091
#Define MEIDM_EDIT_RETURN					10092
#Define MEIDM_EDIT_INDENT					10037
#Define MEIDM_EDIT_OUTDENT					10038
#Define MEIDM_EDIT_COMMENT					10035
#Define MEIDM_EDIT_UNCOMMENT				10036
#Define MEIDM_EDIT_BLOCKCONVERT			10096
#Define MEIDM_EDIT_BLOCKUPPER				10097
#Define MEIDM_EDIT_BLOCKLOWER				10098
#Define MEIDM_EDIT_BLOCKTABTOSPC			10099
#Define MEIDM_EDIT_BLOCKSPCTOTAB			10100
#Define MEIDM_EDIT_BLOCKSPCTRIM			10112
#Define MEIDM_EDIT_BLOCKMODE				10061
#Define MEIDM_EDIT_BLOCKINSERT			10062
#Define MEIDM_EDIT_TOGGLEBM				10018
#Define MEIDM_EDIT_NEXTBM					10019
#Define MEIDM_EDIT_PREVBM					10020
#Define MEIDM_EDIT_CLEARBM					10021
#Define MEIDM_EDIT_CLEARERRORS			10074
#Define MEIDM_EDIT_NEXTERROR				10075

#Define MEIDM_FORMAT							11002
#Define MEIDM_FORMAT_LOCK					10012
#Define MEIDM_FORMAT_BACK					10013
#Define MEIDM_FORMAT_FRONT					10014
#Define MEIDM_FORMAT_GRID					10015
#Define MEIDM_FORMAT_SNAP					10016
#Define MEIDM_FORMAT_ALIGN					10017
#Define MEIDM_FORMAT_ALIGN_LEFT			10034
#Define MEIDM_FORMAT_ALIGN_CENTER		10042
#Define MEIDM_FORMAT_ALIGN_RIGHT			10043
#Define MEIDM_FORMAT_ALIGN_TOP			10044
#Define MEIDM_FORMAT_ALIGN_MIDDLE		10045
#Define MEIDM_FORMAT_ALIGN_BOTTOM		10046
#Define MEIDM_FORMAT_SIZE					10033
#Define MEIDM_FORMAT_SIZE_WIDTH			10039
#Define MEIDM_FORMAT_SIZE_HEIGHT			10040
#Define MEIDM_FORMAT_SIZE_BOTH			10041
#Define MEIDM_FORMAT_CENTER				10066
#Define MEIDM_FORMAT_CENTER_HOR			10067
#Define MEIDM_FORMAT_CENTER_VERT			10068
#Define MEIDM_FORMAT_TABINDEX				10069

#Define MEIDM_VIEW							11003
#Define MEIDM_VIEW_TOOLBAR					10008
#Define MEIDM_VIEW_STATUSBAR				10009
#Define MEIDM_VIEW_OUTPUT					10023
#Define MEIDM_VIEW_DIALOG					10065
#Define MEIDM_VIEW_FILEBROWSER			10059
#Define MEIDM_VIEW_NEXTTAB					10116
#Define MEIDM_VIEW_PREVIOUSTAB			10117

#Define MEIDM_RESOURCE						11004
#Define MEIDM_RESOURCE_DIALOG				10048
#Define MEIDM_RESOURCE_MENU				10049
#Define MEIDM_RESOURCE_ACCEL				10050
#Define MEIDM_RESOURCE_VERINF				10051
#Define MEIDM_RESOURCE_MANIFEST			10071
#Define MEIDM_RESOURCE_RCDATA				10072
#Define MEIDM_RESOURCE_TOOLBAR			10073
#Define MEIDM_RESOURCE_LANGUAGE			10064
#Define MEIDM_RESOURCE_INCLUDE			10052
#Define MEIDM_RESOURCE_RESOURCE			10053
#Define MEIDM_RESOURCE_STRING				10054
#Define MEIDM_RESOURCE_NAME				10055
#Define MEIDM_RESOURCE_EXPORT				10063
#Define MEIDM_RESOURCE_REMOVE				10056
#Define MEIDM_RESOURCE_UNDO				10057

#Define MEIDM_MAKE							11005
#Define MEIDM_MAKE_COMPILE					10024
#Define MEIDM_MAKE_ASSEMBLE				10025
#Define MEIDM_MAKE_LINK						10026
#Define MEIDM_MAKE_BUILD					10090
#Define MEIDM_MAKE_RUN						10027
#Define MEIDM_MAKE_GO						10028
#Define MEIDM_DEBUG							10113
#Define MEIDM_DEBUG_TOGGLE					10082
#Define MEIDM_DEBUG_CLEAR					10083
#Define MEIDM_DEBUG_RUN						10081
#Define MEIDM_DEBUG_BREAK					10089
#Define MEIDM_DEBUG_STOP					10084
#Define MEIDM_DEBUG_INTO					10085
#Define MEIDM_DEBUG_OVER					10086
#Define MEIDM_DEBUG_CARET					10087
#Define MEIDM_DEBUG_NODEBUG				10088
#Define MEIDM_MAKE_MAINFILE				10079

#Define MEIDM_TOOLS							11005

#Define MEIDM_OPTION							11006
#Define MEIDM_OPTION_CODE					10030
#Define MEIDM_OPTION_DIALOG				10047
#Define MEIDM_OPTION_PATH					10080
#Define MEIDM_OPTION_BUILD					10070
#Define MEIDM_OPTION_ADDINS				10093
#Define MEIDM_OPTION_TOOLS					10031
#Define MEIDM_OPTION_HELP					10032
#Define MEIDM_OPTION_EXTERNAL				10076

#Define MEIDM_HELP							11007
#Define MEIDM_HELP_ABOUT					10201

#Define MEIDR_MENUCONTEXT					21000
#Define MEIDM_TABTOOL						21001
#Define MEIDM_FILE_CLOSE_ALL_BUT			21002
#Define MEIDM_OUTPUT_CLEAR					21004
#Define MEIDM_IMMEDIATE_CLEAR				21013
#Define MEIDM_BROWSER_OPEN					21006
#Define MEIDM_BROWSER_COPY					21007
#Define MEIDM_PROPERTY_GOTODECLARE		21010
#Define MEIDM_PROPERTY_COPYTOCODE		21011
#Define MEIDM_PROPERTY_COPYPROTO			21014
#Define MEIDM_PROJECT						21015
#Define MEIDM_PROJECT_CREATE				21022
#Define MEIDM_PROJECT_OPEN					10114
#Define MEIDM_PROJECT_CLOSE				10115
#Define MEIDM_PROJECT_ADDITEM				21023
#Define MEIDM_PROJECT_ADDGROUP			21016
#Define MEIDM_PROJECT_ADDFILE				21019
#Define MEIDM_PROJECT_ADDALLFILES		21020
#Define MEIDM_PROJECT_ADDEXISTINGFILE	21027
#Define MEIDM_PROJECT_ADDNEWFILE			21028
#Define MEIDM_PROJECT_REMOVEITEM			21024
#Define MEIDM_PROJECT_REMOVEGROUP		21017
#Define MEIDM_PROJECT_REMOVEFILE			21021
#Define MEIDM_PROJECT_EDITITEM			21025
#Define MEIDM_PROJECT_EDITGROUP			21018
#Define MEIDM_PROJECT_EDITFILE			21026
'/