/'
 ' ProjPub - Help Addin for FbEdit (FreeBASIC Editor)
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 ' As a special exception, Arnel A. Borja gives unlimited permission to copy, 
 ' distribute and modify the files that are the output of this program, and to 
 ' copy and distribute the resulting files under terms of your choice.  You need 
 ' not follow the terms of the GNU General Public License when using or 
 ' distributing such files, even though portions of the text of the program 
 ' appear in them.  The GNU General Public License (GPL) does govern all other 
 ' use of the material that constitutes the program.
 '
 ' This special exception to the GPL applies to versions of the program released 
 ' by Arnel A. Borja.  When you make and distribute a modified version of the 
 ' program, you may extend this special exception to the GPL to apply to your 
 ' modified version as well.
 '
 '/


#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#include "file.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "Settings.bi"
#Include Once "FileFuncs.bi"
#Include Once "Header.bi"
#Include Once "Help.bi"
#Include Once "License.bi"
#Include Once "Resource.bi"


Declare Function GetLicenseId( ByRef filename As Const String ) As Integer


Function LicenseDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			' Translate dialog box
			TranslateAddinDialog( hWin, IDD_DLGLICENSE )

			' Add header
			AddHeaderToPage( hWin, _
				GetTranslateString( "4006", "License" ), _
				GetTranslateString( "4007", "Choose the license you want to show in the installer." ) _
				)

			' Set limit of text
			SendDlgItemMessage( hWin, IDC_EDTLICENSECUSTOM, EM_SETLIMITTEXT, MAX_PATH, NULL )

			' Add licenses to list box
			If LicensesNum Then
				For i As Integer = 0 To LicensesNum-1
					Dim LicenseName As String = *Licenses( i ).Name
					If *Licenses( i ).Version <> "" Then
						LicenseName += " (version " + *Licenses( i ).Version + ")"
					End If
					SendDlgItemMessage( hWin, IDC_LSTLICENSEFOUND, LB_ADDSTRING, NULL, Cast( LPARAM, StrPtr( LicenseName ) ) )
				Next
				SendDlgItemMessage( hWin, IDC_LSTLICENSEFOUND, LB_SETCURSEL, Cast( WPARAM, LicenseDefault ), NULL )
			End If

			' Set defaults
			Dim CurLicense As Integer = GetLicenseId( ProjectSettings.License )
			If CurLicense <> -1 Then
				CheckDlgButton( hWin, IDC_RBNLICENSEFOUND, BST_CHECKED )
				EnableDlgItem( hWin, IDC_LSTLICENSEFOUND, TRUE )
				EnableDlgItem( hWin, IDC_EDTLICENSECUSTOM, FALSE )
				EnableDlgItem( hWin, IDC_BTNLICENSECUSTOM, FALSE )
				SendDlgItemMessage( hWin, IDC_LSTLICENSEFOUND, LB_SETCURSEL, Cast( WPARAM, CurLicense ), NULL )
			ElseIf ProjectSettings.License <> "" Then
				SetDlgItemText( hWin, IDC_EDTLICENSECUSTOM, @ProjectSettings.License )
				CheckDlgButton( hWin, IDC_RBNLICENSECUSTOM, BST_CHECKED )
				EnableDlgItem( hWin, IDC_LSTLICENSEFOUND, FALSE )
				EnableDlgItem( hWin, IDC_EDTLICENSECUSTOM, TRUE )
				EnableDlgItem( hWin, IDC_BTNLICENSECUSTOM, TRUE )
			Else
				CheckDlgButton( hWin, IDC_RBNLICENSENONE, BST_CHECKED )
				EnableDlgItem( hWin, IDC_LSTLICENSEFOUND, FALSE )
				EnableDlgItem( hWin, IDC_EDTLICENSECUSTOM, FALSE )
				EnableDlgItem( hWin, IDC_BTNLICENSECUSTOM, FALSE )
			End If

			Return FALSE
			'
		Case WM_COMMAND
			Select Case HiWord( wParam )
				Case BN_CLICKED
					Select Case LoWord( wParam )
						Case IDC_RBNLICENSEFOUND
							If IsDlgButtonChecked( hWin, IDC_RBNLICENSEFOUND ) = BST_CHECKED Then
								EnableDlgItem( hWin, IDC_LSTLICENSEFOUND, TRUE )
								EnableDlgItem( hWin, IDC_EDTLICENSECUSTOM, FALSE )
								EnableDlgItem( hWin, IDC_BTNLICENSECUSTOM, FALSE )
							End If
							'
						Case IDC_RBNLICENSECUSTOM
							If IsDlgButtonChecked( hWin, IDC_RBNLICENSECUSTOM ) = BST_CHECKED Then
								EnableDlgItem( hWin, IDC_LSTLICENSEFOUND, FALSE )
								EnableDlgItem( hWin, IDC_EDTLICENSECUSTOM, TRUE )
								EnableDlgItem( hWin, IDC_BTNLICENSECUSTOM, TRUE )
							End If
							'
						Case IDC_RBNLICENSENONE
							If IsDlgButtonChecked( hWin, IDC_RBNLICENSENONE ) = BST_CHECKED Then
								EnableDlgItem( hWin, IDC_LSTLICENSEFOUND, FALSE )
								EnableDlgItem( hWin, IDC_EDTLICENSECUSTOM, FALSE )
								EnableDlgItem( hWin, IDC_BTNLICENSECUSTOM, FALSE )
							End If
							'
						Case IDC_BTNLICENSECUSTOM
							Dim LicenseFile As String = GetRelativePath( _
								OpenFileName( _
									hWin, _
									GetTranslateString( "6001", "Select License File" ), _
									CurProjectPath, _
									!"License Files (*.txt, *.rtf)\0*.txt;*.rtf\0" _
									), _
								CurProjectPath _
								)
							If LicenseFile <> "" Then _
								SetDlgItemText( hWin, IDC_EDTLICENSECUSTOM, LicenseFile )
							'
					End Select
					'
			End Select
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_BACK Or PSWIZB_NEXT )
					'
				Case PSN_WIZNEXT
					If IsDlgButtonChecked( hWin, IDC_RBNLICENSEFOUND ) = BST_CHECKED Then
						Dim CurLicense As Integer = SendDlgItemMessage( hWin, IDC_LSTLICENSEFOUND, LB_GETCURSEL, NULL, NULL )
						If CurLicense >= 0 Then
							ProjectSettings.License = IDEPath + "\ProjPub\Licenses\" + *Licenses( CurLicense ).Contents
						Else
							ProjectSettings.License = ""
						End If
					ElseIf IsDlgButtonChecked( hWin, IDC_RBNLICENSECUSTOM ) = BST_CHECKED Then
						GetDlgItemText( hWin, IDC_EDTLICENSECUSTOM, @ProjectSettings.License, MAX_PATH )
					ElseIf IsDlgButtonChecked( hWin, IDC_RBNLICENSENONE ) = BST_CHECKED Then
						ProjectSettings.License = ""
					End If
					'
			End Select
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function


Sub LoadLicenses( _
	ByRef Location As Const String _
	)

	LicensesNum = 0
	LicensesMax = 0

	' Get first file
	Dim fname As String = Dir( Location & "\*.lic" )
	Dim size As Integer
	
	' Check if fname is valid
	Do While Len( fname )

		' Check FileType
		GetPrivateProfileString( "ProjPub", "FileType", "", @buffer, MAX_PATH, Location + "\" + fname )

		If buffer = "License" Then

			' Check if the array can accomodate the number of files available
			If LicensesNum >= LicensesMax Then
	
				'' There are more files than the array can provide
				LicensesMax += LICENSES_INCREASE
				ReDim Preserve Licenses(LicensesMax - 1) As License
	
			End If
	
			' Set filename of the current Licenses
			Licenses( LicensesNum ).DescFile = New Byte[Len(fname)+1]
			*Licenses( LicensesNum ).DescFile = fname
	
			' Set license info
			size = GetPrivateProfileString( "License", "Name", "Unnamed", @buffer, MAX_PATH, Location + "\" + fname )
			Licenses( LicensesNum ).Name = New Byte[size+1]
			*Licenses( LicensesNum ).Name = buffer
			size = GetPrivateProfileString( "License", "Version", "", @buffer, MAX_PATH, Location + "\" + fname )
			Licenses( LicensesNum ).Version = New Byte[size+1]
			*Licenses( LicensesNum ).Version = buffer
			size = GetPrivateProfileString( "License", "Contents", "", @buffer, MAX_PATH, Location + "\" + fname )
			Licenses( LicensesNum ).Contents = New Byte[size+1]
			*Licenses( LicensesNum ).Contents = buffer
	
			' Check if default is requested
			If GetPrivateProfileInt( "ProjPub", "Default", 0, Location + "\" + fname ) Then
				LicenseDefault = LicensesNum
			End If
	
			' Increment Licenses counter
			LicensesNum += 1

		End If

		' Get next file name
		fname = Dir( "" )

	Loop

End Sub


Sub FreeLicenses( _
	)

	If LicensesNum Then
		For i As Integer = 0 To LicensesNum-1
			Delete[] Licenses( i ).Name
			Delete[] Licenses( i ).DescFile
			Delete[] Licenses( i ).Version
			Delete[] Licenses( i ).Contents
		Next
		LicensesNum = 0
	End If

End Sub


Function GetLicenseId( _
	ByRef filename As Const String _
	) As Integer

	If LicensesNum Then
		For i As Integer = 0 To LicensesNum-1
			If LCase( GetFileName( *Licenses(i).Contents ) ) = LCase( GetFileName( filename ) ) Then
				Return i
			End If
		Next
	End If

	Return -1

End Function

