/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEd
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 ' As a special exception, Arnel A. Borja gives unlimited permission to copy, 
 ' distribute and modify the files that are the output of this program, and to 
 ' copy and distribute the resulting files under terms of your choice.  You need 
 ' not follow the terms of the GNU General Public License when using or 
 ' distributing such files, even though portions of the text of the program 
 ' appear in them.  The GNU General Public License (GPL) does govern all other 
 ' use of the material that constitutes the program.
 '
 ' This special exception to the GPL applies to versions of the program released 
 ' by Arnel A. Borja.  When you make and distribute a modified version of the 
 ' program, you may extend this special exception to the GPL to apply to your 
 ' modified version as well.
 '
 '/


#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "File.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "ProjType.bi"
#Include Once "Settings.bi"
#Include Once "Header.bi"
#Include Once "Help.bi"
#Include Once "PostOptions.bi"
#Include Once "Resource.bi"


Function PostOptionsDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			' Translate dialog box
			TranslateAddinDialog( hWin, IDD_DLGPOSTOPTIONS )

			' Add header
			AddHeaderToPage( hWin, _
				GetTranslateString( "4036", "Post Install Options" ), _
				GetTranslateString( "4037", "Choose options to be shown in Finish page." ) _
				)

			' Set limit of text
			SendDlgItemMessage( hWin, IDC_EDTPOSTOPTIONSRUN, EM_SETLIMITTEXT, MAX_PROJSETTINGS_RUNTEXT, NULL )
			SendDlgItemMessage( hWin, IDC_EDTPOSTOPTIONSRUNPARAMS, EM_SETLIMITTEXT, MAX_PROJSETTINGS_RUNPARAMS, NULL )
			SendDlgItemMessage( hWin, IDC_EDTPOSTOPTIONSRUNFUNC, EM_SETLIMITTEXT, MAX_PROJSETTINGS_RUNFUNCTION, NULL )
			SendDlgItemMessage( hWin, IDC_EDTPOSTOPTIONSSHOWREADME, EM_SETLIMITTEXT, MAX_PROJSETTINGS_SHOWREADMETEXT, NULL )
			SendDlgItemMessage( hWin, IDC_EDTPOSTOPTIONSSHOWREADMEFILEURL, EM_SETLIMITTEXT, MAX_PATH, NULL )
			SendDlgItemMessage( hWin, IDC_EDTPOSTOPTIONSSHOWREADMEFUNC, EM_SETLIMITTEXT, MAX_PROJSETTINGS_SHOWREADMEFUNCTION, NULL )
			SendDlgItemMessage( hWin, IDC_EDTPOSTOPTIONSWEBSITELINK, EM_SETLIMITTEXT, MAX_PROJSETTINGS_POSTWEBLINK, NULL )

			If (ProjectSettings.RunOptions And PROJPUB_POSTOPTIONS_RUNENABLED) <> 0 Then
				CheckDlgButton( hWin, IDC_CHKPOSTOPTIONSRUN, BST_CHECKED )
			Else
				EnableDlgItem( hWin, IDC_CHKPOSTOPTIONSRUNNOTCHECKED, FALSE )
				EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSRUN, FALSE )
				EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSRUNPARAMS, FALSE )
				EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSRUNFUNC, FALSE )
			End If
			If (ProjectSettings.RunOptions And PROJPUB_POSTOPTIONS_RUNNOTCHECKED) <> 0 Then
				CheckDlgButton( hWin, IDC_CHKPOSTOPTIONSRUNNOTCHECKED, BST_CHECKED )
			End If
			SetDlgItemText( hWin, IDC_EDTPOSTOPTIONSRUN, @ProjectSettings.RunText )
			SetDlgItemText( hWin, IDC_EDTPOSTOPTIONSRUNPARAMS, @ProjectSettings.RunParameters )
			SetDlgItemText( hWin, IDC_EDTPOSTOPTIONSRUNFUNC, @ProjectSettings.RunFunction )

			If (ProjectSettings.ShowReadmeOptions And PROJPUB_POSTOPTIONS_SHOWREADMEENABLED) <> 0 Then
				CheckDlgButton( hWin, IDC_CHKPOSTOPTIONSSHOWREADME, BST_CHECKED )
			Else
				EnableDlgItem( hWin, IDC_CHKPOSTOPTIONSSHOWREADMENOTCHECKED, FALSE )
				EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSSHOWREADME, FALSE )
				EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSSHOWREADMEFILEURL, FALSE )
				EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSSHOWREADMEFUNC, FALSE )
			End If
			If (ProjectSettings.ShowReadmeOptions And PROJPUB_POSTOPTIONS_SHOWREADMENOTCHECKED) <> 0 Then
				CheckDlgButton( hWin, IDC_CHKPOSTOPTIONSSHOWREADMENOTCHECKED, BST_CHECKED )
			End If
			SetDlgItemText( hWin, IDC_EDTPOSTOPTIONSSHOWREADME, @ProjectSettings.ShowReadmeText )
			SetDlgItemText( hWin, IDC_EDTPOSTOPTIONSSHOWREADMEFILEURL, @ProjectSettings.ShowReadmeFileUrl )
			SetDlgItemText( hWin, IDC_EDTPOSTOPTIONSSHOWREADMEFUNC, @ProjectSettings.ShowReadmeFunction )

			If (ProjectSettings.WebsiteLinkOptions And PROJPUB_POSTOPTIONS_POSTWEBLINKENABLED) <> 0 Then
				CheckDlgButton( hWin, IDC_CHKPOSTOPTIONSWEBSITELINK, BST_CHECKED )
			Else
				EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSWEBSITELINK, FALSE )
			End If
			SetDlgItemText( hWin, IDC_EDTPOSTOPTIONSWEBSITELINK, @ProjectSettings.WebsiteLinkText )

			'
		Case WM_COMMAND
			Select Case HiWord( wParam )
				Case BN_CLICKED
					Select Case LoWord( wParam )
						Case IDC_CHKPOSTOPTIONSRUN
							If IsDlgButtonChecked( hWin, IDC_CHKPOSTOPTIONSRUN ) = BST_CHECKED Then
								EnableDlgItem( hWin, IDC_CHKPOSTOPTIONSRUNNOTCHECKED, TRUE )
								EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSRUN, TRUE )
								EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSRUNPARAMS, TRUE )
								EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSRUNFUNC, TRUE )
							Else
								EnableDlgItem( hWin, IDC_CHKPOSTOPTIONSRUNNOTCHECKED, FALSE )
								EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSRUN, FALSE )
								EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSRUNPARAMS, FALSE )
								EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSRUNFUNC, FALSE )
							End If
							'
						Case IDC_CHKPOSTOPTIONSSHOWREADME
							If IsDlgButtonChecked( hWin, IDC_CHKPOSTOPTIONSSHOWREADME ) = BST_CHECKED Then
								EnableDlgItem( hWin, IDC_CHKPOSTOPTIONSSHOWREADMENOTCHECKED, TRUE )
								EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSSHOWREADME, TRUE )
								EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSSHOWREADMEFILEURL, TRUE )
								EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSSHOWREADMEFUNC, TRUE )
							Else
								EnableDlgItem( hWin, IDC_CHKPOSTOPTIONSSHOWREADMENOTCHECKED, FALSE )
								EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSSHOWREADME, FALSE )
								EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSSHOWREADMEFILEURL, FALSE )
								EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSSHOWREADMEFUNC, FALSE )
							End If
							'
						Case IDC_CHKPOSTOPTIONSWEBSITELINK
							If IsDlgButtonChecked( hWin, IDC_CHKPOSTOPTIONSWEBSITELINK ) = BST_CHECKED Then
								EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSWEBSITELINK, TRUE )
							Else
								EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSWEBSITELINK, FALSE )
							End If
							'
					End Select
					'
			End Select
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_BACK Or PSWIZB_NEXT )
					If ProjectSettings.ProjectType = PROJPUB_PROJTYPE_FBEADDIN Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_RAADDIN Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_MEADDIN Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_APPPLUGIN Then
						EnableDlgItem( hWin, IDC_CHKPOSTOPTIONSRUN, FALSE )
						EnableDlgItem( hWin, IDC_CHKPOSTOPTIONSRUNNOTCHECKED, FALSE )
						EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSRUN, FALSE )
						EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSRUNPARAMS, FALSE )
						EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSRUNFUNC, FALSE )
					Else
						EnableDlgItem( hWin, IDC_CHKPOSTOPTIONSRUN, TRUE )
						EnableDlgItem( hWin, IDC_CHKPOSTOPTIONSRUNNOTCHECKED, TRUE )
						EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSRUN, TRUE )
						EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSRUNPARAMS, TRUE )
						EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSRUNFUNC, TRUE )
					End If
					If ProjectSettings.ProjectLink <> "" Then
						EnableDlgItem( hWin, IDC_CHKPOSTOPTIONSWEBSITELINK, TRUE )
						EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSWEBSITELINK, TRUE )
					Else
						EnableDlgItem( hWin, IDC_CHKPOSTOPTIONSWEBSITELINK, FALSE )
						EnableDlgItem( hWin, IDC_EDTPOSTOPTIONSWEBSITELINK, FALSE )
					End If
					'
				Case PSN_WIZNEXT
					If IsDlgButtonChecked( hWin, IDC_CHKPOSTOPTIONSRUN ) = BST_CHECKED Then
						ProjectSettings.RunOptions Or= PROJPUB_POSTOPTIONS_RUNENABLED
						If IsDlgButtonChecked( hWin, IDC_CHKPOSTOPTIONSRUNNOTCHECKED ) = BST_CHECKED Then
							ProjectSettings.RunOptions Or= PROJPUB_POSTOPTIONS_RUNNOTCHECKED
						Else
							ProjectSettings.RunOptions And= Not PROJPUB_POSTOPTIONS_RUNNOTCHECKED
						End If
						GetDlgItemText( hWin, IDC_EDTPOSTOPTIONSRUN, @ProjectSettings.RunText, MAX_PROJSETTINGS_RUNTEXT )
						GetDlgItemText( hWin, IDC_EDTPOSTOPTIONSRUNPARAMS, @ProjectSettings.RunParameters, MAX_PROJSETTINGS_RUNPARAMS )
						GetDlgItemText( hWin, IDC_EDTPOSTOPTIONSRUNFUNC, @ProjectSettings.RunFunction, MAX_PROJSETTINGS_RUNFUNCTION )
					Else
						ProjectSettings.RunOptions And= Not PROJPUB_POSTOPTIONS_RUNENABLED
					End If

					If IsDlgButtonChecked( hWin, IDC_CHKPOSTOPTIONSSHOWREADME ) = BST_CHECKED Then
						ProjectSettings.ShowReadmeOptions Or= PROJPUB_POSTOPTIONS_SHOWREADMEENABLED
						If IsDlgButtonChecked( hWin, IDC_CHKPOSTOPTIONSSHOWREADMENOTCHECKED ) = BST_CHECKED Then
							ProjectSettings.ShowReadmeOptions Or= PROJPUB_POSTOPTIONS_SHOWREADMENOTCHECKED
						Else
							ProjectSettings.ShowReadmeOptions And= Not PROJPUB_POSTOPTIONS_RUNNOTCHECKED
						End If
						GetDlgItemText( hWin, IDC_EDTPOSTOPTIONSSHOWREADME, @ProjectSettings.ShowReadmeText, MAX_PROJSETTINGS_SHOWREADMETEXT )
						GetDlgItemText( hWin, IDC_EDTPOSTOPTIONSSHOWREADMEFILEURL, @ProjectSettings.ShowReadmeFileUrl, MAX_PATH )
						GetDlgItemText( hWin, IDC_EDTPOSTOPTIONSSHOWREADMEFUNC, @ProjectSettings.ShowReadmeFunction, MAX_PROJSETTINGS_SHOWREADMEFUNCTION )
					Else
						ProjectSettings.ShowReadmeOptions And= Not PROJPUB_POSTOPTIONS_SHOWREADMEENABLED
					End If

					If IsDlgButtonChecked( hWin, IDC_CHKPOSTOPTIONSWEBSITELINK ) = BST_CHECKED Then
						ProjectSettings.WebsiteLinkOptions Or= PROJPUB_POSTOPTIONS_POSTWEBLINKENABLED
						GetDlgItemText( hWin, IDC_EDTPOSTOPTIONSWEBSITELINK, @ProjectSettings.WebsiteLinkText, MAX_PROJSETTINGS_POSTWEBLINK )
					Else
						ProjectSettings.WebsiteLinkOptions And= Not PROJPUB_POSTOPTIONS_POSTWEBLINKENABLED
					End If
					'
			End Select
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function

