/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEd
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 ' As a special exception, Arnel A. Borja gives unlimited permission to copy, 
 ' distribute and modify the files that are the output of this program, and to 
 ' copy and distribute the resulting files under terms of your choice.  You need 
 ' not follow the terms of the GNU General Public License when using or 
 ' distributing such files, even though portions of the text of the program 
 ' appear in them.  The GNU General Public License (GPL) does govern all other 
 ' use of the material that constitutes the program.
 '
 ' This special exception to the GPL applies to versions of the program released 
 ' by Arnel A. Borja.  When you make and distribute a modified version of the 
 ' program, you may extend this special exception to the GPL to apply to your 
 ' modified version as well.
 '
 '/


#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "Settings.bi"
#Include Once "MsgBox.bi"
#Include Once "Header.bi"
#Include Once "Help.bi"
#Include Once "ProjInfo.bi"
#Include Once "Resource.bi"


Function ProjInfoDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			' Translate dialog box
			TranslateAddinDialog( hWin, IDD_DLGPROJINFO )

			' Add header
			AddHeaderToPage( hWin, _
				GetTranslateString( "4002", "Project Information" ), _
				GetTranslateString( "4003", "Please fill the fields below for information about your application." ) _
				)

			' Set limit of text
			SendDlgItemMessage( hWin, IDC_EDTPROJINFONAME, EM_SETLIMITTEXT, MAX_PROJSETTINGS_NAME, NULL )
			SendDlgItemMessage( hWin, IDC_EDTPROJINFODISPVERSION, EM_SETLIMITTEXT, MAX_PROJSETTINGS_VERSION, NULL )
			SendDlgItemMessage( hWin, IDC_EDTPROJINFOAUTHOR, EM_SETLIMITTEXT, MAX_PROJSETTINGS_AUTHOR, NULL )
			SendDlgItemMessage( hWin, IDC_EDTPROJINFOSHORTNAME, EM_SETLIMITTEXT, MAX_PROJSETTINGS_SHORTNAME, NULL )

			' Set default project name
			SetDlgItemText( hWin, IDC_EDTPROJINFONAME, @ProjectSettings.Name )
			' Set default project short name
			SetDlgItemText( hWin, IDC_EDTPROJINFOSHORTNAME, @ProjectSettings.ShortName )
			' Set default author
			SetDlgItemText( hWin, IDC_EDTPROJINFOAUTHOR, @ProjectSettings.Author )
			' Set default version
			SetDlgItemText( hWin, IDC_EDTPROJINFODISPVERSION, @ProjectSettings.Version )
			SetDlgItemInt( hWin, IDC_EDTPROJINFOVERSIONMAJOR, ProjectSettings.VersionMajor, FALSE )
			SetDlgItemInt( hWin, IDC_EDTPROJINFOVERSIONMINOR, ProjectSettings.VersionMinor, FALSE )
			SetDlgItemInt( hWin, IDC_EDTPROJINFOVERSIONBUILD, ProjectSettings.VersionBuild, FALSE )
			SetDlgItemInt( hWin, IDC_EDTPROJINFOVERSIONREVISION, ProjectSettings.VersionRevision, FALSE )
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_BACK Or PSWIZB_NEXT )
					'
				Case PSN_WIZNEXT
					GetDlgItemText( hWin, IDC_EDTPROJINFONAME, @ProjectSettings.Name, MAX_PROJSETTINGS_NAME )
					GetDlgItemText( hWin, IDC_EDTPROJINFODISPVERSION, @ProjectSettings.Version, MAX_PROJSETTINGS_VERSION )
					ProjectSettings.VersionMajor = GetDlgItemInt( hWin, IDC_EDTPROJINFOVERSIONMAJOR, NULL, FALSE )
					ProjectSettings.VersionMinor = GetDlgItemInt( hWin, IDC_EDTPROJINFOVERSIONMINOR, NULL, FALSE )
					ProjectSettings.VersionBuild = GetDlgItemInt( hWin, IDC_EDTPROJINFOVERSIONBUILD, NULL, FALSE )
					ProjectSettings.VersionRevision = GetDlgItemInt( hWin, IDC_EDTPROJINFOVERSIONREVISION, NULL, FALSE )
					GetDlgItemText( hWin, IDC_EDTPROJINFOAUTHOR, @ProjectSettings.Author, MAX_PROJSETTINGS_AUTHOR )
					GetDlgItemText( hWin, IDC_EDTPROJINFOSHORTNAME, @ProjectSettings.ShortName, MAX_PROJSETTINGS_SHORTNAME )
					If ProjectSettings.Name = "" Or _
						ProjectSettings.Author = "" Or _
						ProjectSettings.ShortName = "" Or _
						ProjectSettings.Version = "" Or _
						(ProjectSettings.VersionMajor = 0 And ProjectSettings.VersionMinor = 0 And _
						ProjectSettings.VersionBuild = 0 And ProjectSettings.VersionRevision = 0) Then
						ErrorBox( hWin, GetTranslateString( "5000", "All fields are required." ) )
						SetWindowLong( hWin, DWL_MSGRESULT, -1 )
					End If
					'
			End Select
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function

