/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEd
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 ' As a special exception, Arnel A. Borja gives unlimited permission to copy, 
 ' distribute and modify the files that are the output of this program, and to 
 ' copy and distribute the resulting files under terms of your choice.  You need 
 ' not follow the terms of the GNU General Public License when using or 
 ' distributing such files, even though portions of the text of the program 
 ' appear in them.  The GNU General Public License (GPL) does govern all other 
 ' use of the material that constitutes the program.
 '
 ' This special exception to the GPL applies to versions of the program released 
 ' by Arnel A. Borja.  When you make and distribute a modified version of the 
 ' program, you may extend this special exception to the GPL to apply to your 
 ' modified version as well.
 '
 '/


#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "ProjType.bi"
#Include Once "Settings.bi"
#Include Once "Header.bi"
#Include Once "Help.bi"
#Include Once "ProjWeb.bi"
#Include Once "Resource.bi"


Function ProjWebDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			' Translate dialog box
			TranslateAddinDialog( hWin, IDD_DLGPROJWEB )

			' Add header
			AddHeaderToPage( hWin, _
				GetTranslateString( "4004", "Project Website Links" ), _
				GetTranslateString( "4005", "Please fill the website links of your project." ) _
				)

			' Set limit of text
			SendDlgItemMessage( hWin, IDC_EDTPROJWEBSITE, EM_SETLIMITTEXT, MAX_PROJSETTINGS_PROJLINK, NULL )
			SendDlgItemMessage( hWin, IDC_EDTPROJWEBSUPPORT, EM_SETLIMITTEXT, MAX_PROJSETTINGS_SUPPLINK, NULL )
			SendDlgItemMessage( hWin, IDC_EDTPROJWEBUPDATE, EM_SETLIMITTEXT, MAX_PROJSETTINGS_UPDATELINK, NULL )

			' Set defaults
			SetDlgItemText( hWin, IDC_EDTPROJWEBSITE, @ProjectSettings.ProjectLink )
			SetDlgItemText( hWin, IDC_EDTPROJWEBSUPPORT, @ProjectSettings.SupportLink )
			SetDlgItemText( hWin, IDC_EDTPROJWEBUPDATE, @ProjectSettings.UpdateLink )
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_BACK Or PSWIZB_NEXT )
					If ProjectSettings.ProjectType = PROJPUB_PROJTYPE_BASIC Then
						SetWindowLong( hWin, DWL_MSGRESULT, -1 )
					End If
					'
				Case PSN_WIZNEXT
					GetDlgItemText( hWin, IDC_EDTPROJWEBSITE, @ProjectSettings.ProjectLink, MAX_PROJSETTINGS_PROJLINK )
					GetDlgItemText( hWin, IDC_EDTPROJWEBSUPPORT, @ProjectSettings.SupportLink, MAX_PROJSETTINGS_SUPPLINK )
					GetDlgItemText( hWin, IDC_EDTPROJWEBUPDATE, @ProjectSettings.UpdateLink, MAX_PROJSETTINGS_UPDATELINK )
					'
			End Select
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function

