/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEd
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 ' As a special exception, Arnel A. Borja gives unlimited permission to copy, 
 ' distribute and modify the files that are the output of this program, and to 
 ' copy and distribute the resulting files under terms of your choice.  You need 
 ' not follow the terms of the GNU General Public License when using or 
 ' distributing such files, even though portions of the text of the program 
 ' appear in them.  The GNU General Public License (GPL) does govern all other 
 ' use of the material that constitutes the program.
 '
 ' This special exception to the GPL applies to versions of the program released 
 ' by Arnel A. Borja.  When you make and distribute a modified version of the 
 ' program, you may extend this special exception to the GPL to apply to your 
 ' modified version as well.
 '
 '/


#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "File.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "Wizard.bi"
#Include Once "Recompile.bi"
#Include Once "MultiUser.bi"
#Include Once "Mui.bi"
#Include Once "RemDrvInst.bi"
#Include Once "Shortcuts.bi"
#Include Once "LangDll.bi"
#Include Once "Compressor.bi"
#Include Once "PostOptions.bi"
#Include Once "Settings.bi"
#Include Once "FileFuncs.bi"
#Include Once "Header.bi"
#Include Once "Help.bi"
#Include Once "Files.bi"
#Include Once "Publish.bi"
#Include Once "Resource.bi"


#Define RUNNSIS_BUFFSIZE						1024

Dim Shared LastPublishResult As Integer
Dim Shared CreateInstallerMsg As MSG

Declare Function CreateInstaller( ByVal lpData As Any Ptr ) As DWORD
Declare Function RunNSIS ( ByVal hWin As HWND, ByRef NSISPath As Const String, ByRef NSISScript As Const String ) As Integer
Declare Function RemoveOldBuilds( ByVal hWin As HWND ) As Integer
Declare Function CreateHeader(  ) As Integer
Declare Function CreateScript(  ) As Integer


Function PublishDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Static ThreadHandle As HANDLE

	Select Case uMsg
		Case WM_INITDIALOG
			' Translate dialog box
			TranslateAddinDialog( hWin, IDD_DLGPUBLISH )

			' Add header
			AddHeaderToPage( hWin, _
				GetTranslateString( "4032", "Publishing Your Application" ), _
				GetTranslateString( "4033", "Please wait while the wizard is publishing your application." ) _
				)

			' Set progress bar settings
			If Recompile Then
				SendDlgItemMessage( hWin, IDC_PGBPUBLISH, PBM_SETRANGE, 0, MAKELPARAM(0, 2) )
			Else
				SendDlgItemMessage( hWin, IDC_PGBPUBLISH, PBM_SETRANGE, 0, MAKELPARAM(0, 3) )
			End If
			SendDlgItemMessage( hWin, IDC_PGBPUBLISH, PBM_SETSTEP, Cast( WPARAM, 1), 0 )

			' Set list view settings
			Dim ListViewColumn As LV_COLUMN
			With ListViewColumn
				.imask	= LVCF_SUBITEM Or LVCF_WIDTH
				' TODO: Doesn't work as expected
				.lx		= (LoWord(GetDialogBaseUnits) * 250) / 4
			End With
			SendDlgItemMessage( hWin, IDC_LSVPUBLISH, LVM_INSERTCOLUMN, 0, Cast( LPARAM, @ListViewColumn ) )
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_BACK )

					' Compile script
					Dim ThreadId As Integer
					CreateInstallerMsg.hwnd = hWin
					CreateInstallerMsg.message = uMsg
					CreateInstallerMsg.wParam = wParam
					CreateInstallerMsg.lParam = lParam
					ThreadHandle = CreateThread( _
						NULL, _
						0, _
						@CreateInstaller, _
						@CreateInstallerMsg, _
						0, _
						@ThreadId _
						)
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_NEXT )
					'
				Case PSN_WIZNEXT
					If ThreadHandle Then
						Dim ExitCode As Integer
						GetExitCodeThread( ThreadHandle, @ExitCode )
						If ExitCode = STILL_ACTIVE Then
							SetWindowLong( hWin, DWL_MSGRESULT, -1 )
							Return TRUE
						Else
							ThreadHandle = NULL
							LastPublishResult = ExitCode
						End If
					End If
					If LastPublishResult <> 0 Then
						SendMessage( Cast( NMHDR Ptr, lParam )->hwndFrom, PSM_SETCURSEL, PROJPUB_WIZPAGE_FAILED, 0 )
						SetWindowLong( hWin, DWL_MSGRESULT, -1 )
					End If
					'
				Case PSN_QUERYCANCEL
					If ThreadHandle Then
						Dim ExitCode As Integer
						GetExitCodeThread( ThreadHandle, @ExitCode )
						If ExitCode = STILL_ACTIVE Then
							SetWindowLong( hWin, DWL_MSGRESULT, -1 )
							Return TRUE
						Else
							ThreadHandle = NULL
							LastPublishResult = ExitCode
						End If
					End If
					'
			End Select
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function


Function CreateInstaller( _
	ByVal lpData As Any Ptr _
	) As DWORD

	Dim lpMsg As MSG Ptr = lpData
	Dim ListViewItem As LV_ITEM

	With ListViewItem
		.imask	= LVIF_TEXT
		.iItem	= 0
		.pszText	= @buffer
	End With

	SendDlgItemMessage( lpMsg->hwnd, IDC_LSVPUBLISH, LVM_DELETEALLITEMS, 0, 0 )

	buffer = GetTranslateString( "6006", "Removing older builds:" )
	ListViewItem.iItem = ListView_GetItemCount( GetDlgItem( lpMsg->hwnd, IDC_LSVPUBLISH ) )
	SendDlgItemMessage( lpMsg->hwnd, IDC_LSVPUBLISH, LVM_INSERTITEM, 0, Cast( LPARAM, @ListViewItem ) )

	Dim OldBuilds As Integer = RemoveOldBuilds( GetDlgItem( lpMsg->hwnd, IDC_LSVPUBLISH ) )

	If OldBuilds >= 0 Then
		SendDlgItemMessage( lpMsg->hwnd, IDC_PGBPUBLISH, PBM_STEPIT, 0, 0 )
		If OldBuilds = 0 Then
			buffer = GetTranslateString( "6007", "None found." )
			ListViewItem.iItem = ListView_GetItemCount( GetDlgItem( lpMsg->hwnd, IDC_LSVPUBLISH ) )
			SendDlgItemMessage( lpMsg->hwnd, IDC_LSVPUBLISH, LVM_INSERTITEM, 0, Cast( LPARAM, @ListViewItem ) )
		End If
	Else
		If Recompile = 0 Then
			SendDlgItemMessage( lpMsg->hwnd, IDC_PGBPUBLISH, PBM_SETPOS, 3, 0 )
		Else
			SendDlgItemMessage( lpMsg->hwnd, IDC_PGBPUBLISH, PBM_SETPOS, 2, 0 )
		End If
		buffer = GetTranslateString( "6008", "Failed to remove an older build." )
		ListViewItem.iItem = ListView_GetItemCount( GetDlgItem( lpMsg->hwnd, IDC_LSVPUBLISH ) )
		SendDlgItemMessage( lpMsg->hwnd, IDC_LSVPUBLISH, LVM_INSERTITEM, 0, Cast( LPARAM, @ListViewItem ) )
		PropSheet_SetWizButtons( Cast( NMHDR Ptr, lpMsg->lParam )->hwndFrom, PSWIZB_NEXT )
		Return -1
	End If

	If Recompile = 0 Then

		buffer = GetTranslateString( "6009", "Creating NSIS Script File." )
		ListViewItem.iItem = ListView_GetItemCount( GetDlgItem( lpMsg->hwnd, IDC_LSVPUBLISH ) )
		SendDlgItemMessage( lpMsg->hwnd, IDC_LSVPUBLISH, LVM_INSERTITEM, 0, Cast( LPARAM, @ListViewItem ) )

		If CreateScript(  ) = 0 Then
			SendDlgItemMessage( lpMsg->hwnd, IDC_PGBPUBLISH, PBM_STEPIT, 0, 0 )
		Else
			SendDlgItemMessage( lpMsg->hwnd, IDC_PGBPUBLISH, PBM_SETPOS, 3, 0 )
			buffer = GetTranslateString( "6010", "Failed to create the NSIS Script File." )
			ListViewItem.iItem = ListView_GetItemCount( GetDlgItem( lpMsg->hwnd, IDC_LSVPUBLISH ) )
			SendDlgItemMessage( lpMsg->hwnd, IDC_LSVPUBLISH, LVM_INSERTITEM, 0, Cast( LPARAM, @ListViewItem ) )
			PropSheet_SetWizButtons( Cast( NMHDR Ptr, lpMsg->lParam )->hwndFrom, PSWIZB_NEXT ) 
			Return -1
		End If

	End If

	buffer = GetTranslateString( "6011", "Compiling NSIS Source File." )
	ListViewItem.iItem = ListView_GetItemCount( GetDlgItem( lpMsg->hwnd, IDC_LSVPUBLISH ) )
	SendDlgItemMessage( lpMsg->hwnd, IDC_LSVPUBLISH, LVM_INSERTITEM, 0, Cast( LPARAM, @ListViewItem ) )

	Dim RunNSISResult As Integer = RunNSIS( _
		GetDlgItem( lpMsg->hwnd, IDC_LSVPUBLISH ), _
		GlobalSettings.NSISPath, _
		CurProjectPath & "\" & ProjectSettings.ShortName & ".nsi" _
		)

	If RunNSISResult = -1 Then
		buffer = GetTranslateString( "6012", "Failed to execute NSIS." )
	Else
		If FileExists( CurProjectPath & "\" & ProjectSettings.ShortName & "-" & _
			ProjectSettings.VersionMajor & "." & _
			ProjectSettings.VersionMinor & "." & _
			ProjectSettings.VersionBuild & "." & _
			ProjectSettings.VersionRevision & ".exe" _
			) Then
			buffer = GetTranslateString( "6013", "Script compiled succesfully." )
			RunNSISResult = 0
		Else
			buffer = GetTranslateString( "6014", "Script compilation failed." )
			RunNSISResult = 1
		End If
	End If

	ListViewItem.iItem = ListView_GetItemCount( GetDlgItem( lpMsg->hwnd, IDC_LSVPUBLISH ) )
	SendDlgItemMessage( lpMsg->hwnd, IDC_LSVPUBLISH, LVM_INSERTITEM, 0, Cast( LPARAM, @ListViewItem ) )
	SendDlgItemMessage( lpMsg->hwnd, IDC_PGBPUBLISH, PBM_STEPIT, 0, 0 )

	Return RunNSISResult

End Function


Function RunNSIS ( _
	ByVal hWin As HWND, _
	ByRef NSISPath As Const String, _
	ByRef NSISScript As Const String _
	) As Integer

	Dim sat As SECURITY_ATTRIBUTES
	Dim startupinfo As STARTUPINFO
	Dim pInfo As PROCESS_INFORMATION
	Dim bytesRead As DWORD
	Dim ReadHandle As HANDLE
	Dim WriteHandle As HANDLE
	Dim OutBuffer As ZString * RUNNSIS_BUFFSIZE+1
	Dim CurPos As Integer
	Dim ExitCode As Integer
	Dim ListViewItem As LV_ITEM

	With ListViewItem
		.imask	= LVIF_TEXT
		.iItem	= 0
		.pszText	= @OutBuffer
	End With

	With sat
		.nLength						= SizeOf( SECURITY_ATTRIBUTES )
		.lpSecurityDescriptor	= NULL
		.bInheritHandle			= TRUE
	End With

	' Create read and write handles
	If CreatePipe( @ReadHandle, @WriteHandle, @sat, 0 ) = FALSE Then
		' Creating pipes failed
		Return -1
	End If
	
	With startupinfo
		.cb = SizeOf( STARTUPINFO )
	End With

	GetStartupInfo( @startupinfo )

	With startupinfo
		.dwFlags			= STARTF_USESHOWWINDOW Or STARTF_USESTDHANDLES
		.hStdOutput		= WriteHandle
		.hStdError		= WriteHandle
		.wShowWindow	= SW_HIDE
	End With

	If CreateProcess( _
		NSISPath, _								' MakeNSIS Path
		" -V3 """ & NSISScript & """", _	' Command line
		NULL, _									' Process security attributes
		NULL, _									' Primary thread security attributes
		TRUE, _									' Handles are inherited
		0, _										' Creation flags
		NULL, _									' Use parent's environment
		NULL, _									' Use parent's current directory
		@startupinfo, _						' STARTUPINFO pointer
		@pInfo _									' receives PROCESS_INFORMATION
		) = FALSE Then

		' Failed to create process
		CloseHandle( ReadHandle )
		CloseHandle( WriteHandle )
		Return -1

	End If

	CloseHandle( WriteHandle )

	Do
		If ReadFile( ReadHandle, Cast( Any Ptr, @OutBuffer + CurPos ), 1, @bytesRead, NULL ) = FALSE Then
			If CurPos Then
				ListViewItem.iItem = ListView_GetItemCount( hWin )
				SendMessage( hWin, LVM_INSERTITEM, 0, Cast( LPARAM, @ListViewItem ) )
			End If
			Exit Do
		Else
			If OutBuffer[CurPos] = &h0A Or CurPos = RUNNSIS_BUFFSIZE Then
				' Remove LN in end
				If OutBuffer[CurPos] = &h0A Then OutBuffer[CurPos] = NULL
				ListViewItem.iItem = ListView_GetItemCount( hWin )
				SendMessage( hWin, LVM_INSERTITEM, 0, Cast( LPARAM, @ListViewItem ) )
				Clear( OutBuffer, NULL, RUNNSIS_BUFFSIZE )
				CurPos = 0
			ElseIf OutBuffer[CurPos] = &h0D Then
				' Ignore CR
				OutBuffer[CurPos] = NULL
			Else
				CurPos += 1
			End If
		End If
	Loop

	GetExitCodeProcess( pInfo.hProcess, @ExitCode )
	CloseHandle( ReadHandle )
	CloseHandle( pInfo.hThread )
	CloseHandle( pInfo.hProcess )

	Return ExitCode

End Function


Function RemoveOldBuilds( _
	ByVal hWin As HWND _
	) As Integer

	Dim wfd As WIN32_FIND_DATA
	Dim hwfd As HANDLE
	Dim ListViewItem As LV_ITEM
	Dim OldBuilds As Integer

	With ListViewItem
		.imask	= LVIF_TEXT
		.iItem	= 0
		.pszText	= @buffer
	End With

	' Find old builds in project path
	hwfd = FindFirstFile( CurProjectPath & "\" & ProjectSettings.ShortName & "-*.*.*.*.exe", @wfd )
	If hwfd <> INVALID_HANDLE_VALUE Then
		Do
			If (wfd.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) = 0 Then
				' A file is found
				OldBuilds += 1
				buffer = wfd.cFileName
				ListViewItem.iItem = ListView_GetItemCount( hWin )
				SendMessage( hWin, LVM_INSERTITEM, 0, Cast( LPARAM, @ListViewItem ) )
				If Kill( CurProjectPath & "\" & wfd.cFileName ) <> 0 Then Return -1
			End If
			' Get next path
			If FindNextFile( hwfd, @wfd ) = FALSE Then Exit Do
		Loop
		' Close the find handle
		FindClose( hwfd )
	End If

	Return OldBuilds

End Function


Function CreateScript( _
	) As Integer

	Dim File As Integer = FreeFile
	Dim CurFolder As ProjPub_Folder Ptr
	Dim CurFile As ProjPub_File Ptr
	Dim CurFileType As ProjPub_FileType Ptr
	Dim CurLanguage As ProjPub_Lang Ptr
	Dim LastErrorCode As Integer

	LastErrorCode = Open( _
		CurProjectPath & "/" & ProjectSettings.ShortName & ".nsi", _
		For Output, _
		As #File _
		)

	If LastErrorCode <> 0 Then Return LastErrorCode
	
	Print #File, !";" & ProjectSettings.Name
	Print #File, !";NSIS Installer Script"
	Print #File, !";Written with FbEdit Project Publisher"
	Print #File, !""
	Print #File, !";--------------------------------"
	Print #File, !";Set data compressor"
	Print #File, !""
	Print #File, !"\tSetCompressor ";
	If (ProjectSettings.CompressorOptions And PROJPUB_COMPRESSOR_SOLID) <> 0 Then
		Print #File, "/SOLID ";
	End If
	Select Case ProjectSettings.Compressor
		Case PROJPUB_COMPRESSOR_LZMA
			Print #File, "lzma"
			'
		Case PROJPUB_COMPRESSOR_ZLIB
			Print #File, "zlib"
			'
		Case PROJPUB_COMPRESSOR_BZIP2
			Print #File, "bzip2"
			'
	End Select
	Print #File, !""
	Print #File, !";--------------------------------"
	Print #File, !";Defines"
	Print #File, !""
	Print #File, !"\t!define PRODUCT_NAME\t\t\t\t\t\t""" & ProjectSettings.Name & """"
	Print #File, !"\t!define PRODUCT_FILE\t\t\t\t\t\t""" & ProjectSettings.ShortName & """"
	Print #File, !"\t!define PRODUCT_LICENSE\t\t\t\t\t\t""" & ProjectSettings.License & """"
	If ProjectSettings.IconInstall <> "" Then Print #File, !"\t!define PRODUCT_ICON\t\t\t\t\t\t""" & ProjectSettings.IconInstall & """"
	If ProjectSettings.IconUninstall <> "" Then Print #File, !"\t!define PRODUCT_UNICON\t\t\t\t\t\t""" & ProjectSettings.IconUninstall & """"
	If ProjectSettings.HeaderInstall <> "" Then Print #File, !"\t!define PRODUCT_HEADERIMAGE_BITMAP\t\t\t""" & ProjectSettings.HeaderInstall & """"
	If ProjectSettings.HeaderUninstall <> "" Then Print #File, !"\t!define PRODUCT_HEADERIMAGE_UNBITMAP\t\t""" & ProjectSettings.HeaderUninstall & """"
	If ProjectSettings.HeaderInstallRight <> "" Then Print #File, !"\t!define PRODUCT_HEADERIMAGE_BITMAP_RTL\t\t""" & ProjectSettings.HeaderInstallRight & """"
	If ProjectSettings.HeaderUninstallRight <> "" Then Print #File, !"\t!define PRODUCT_HEADERIMAGE_UNBITMAP_RTL\t""" & ProjectSettings.HeaderUninstallRight & """"
	If ProjectSettings.WizardInstall <> "" Then Print #File, !"\t!define PRODUCT_WELCOMEFINISHPAGE_BITMAP\t""" & ProjectSettings.WizardInstall & """"
	If ProjectSettings.WizardUninstall <> "" Then Print #File, !"\t!define PRODUCT_UNWELCOMEFINISHPAGE_BITMAP\t""" & ProjectSettings.WizardUninstall & """"
	Print #File, !"\t!define PRODUCT_REGISTRY_KEY\t\t\t\t""" & ProjectSettings.ShortName & """"
	Print #File, !"\t!define PRODUCT_INSTALL_DIR\t\t\t\t\t""" & ProjectSettings.InstallFolder & """"
	Print #File, !"\t!define PRODUCT_AUTHOR\t\t\t\t\t\t""" & ProjectSettings.Author & """"
	If ProjectSettings.ProjectLink <> "" Then Print #File, !"\t!define PRODUCT_WEB_SITE\t\t\t\t\t""" & ProjectSettings.ProjectLink & """"
	If ProjectSettings.SupportLink <> "" Then Print #File, !"\t!define PRODUCT_WEB_FORUM\t\t\t\t\t""" & ProjectSettings.SupportLink & """"
	If ProjectSettings.UpdateLink <> "" Then Print #File, !"\t!define PRODUCT_WEB_UPDATE\t\t\t\t\t""" & ProjectSettings.UpdateLink & """"
	Print #File, !"\t!define PRODUCT_DISPLAY_VERSION\t\t\t\t""" & ProjectSettings.Version & """"
	Print #File, !"\t!define PRODUCT_VERSION_MAJOR\t\t\t\t""" & ProjectSettings.VersionMajor & """"
	Print #File, !"\t!define PRODUCT_VERSION_MINOR\t\t\t\t""" & ProjectSettings.VersionMinor & """"
	Print #File, !"\t!define PRODUCT_VERSION_BUILD\t\t\t\t""" & ProjectSettings.VersionBuild & """"
	Print #File, !"\t!define PRODUCT_VERSION_REVISION\t\t\t""" & ProjectSettings.VersionRevision & """"
	Print #File, !"\t!define PRODUCT_VERSION\t\t\t\t\t\t""${PRODUCT_VERSION_MAJOR}.${PRODUCT_VERSION_MINOR}.${PRODUCT_VERSION_BUILD}.${PRODUCT_VERSION_REVISION}"""
	Print #File, !""
	Print #File, !";--------------------------------"
	Print #File, !";Include nsDialogs"
	Print #File, !""
	Print #File, !"\t!include LogicLib.nsh"
	Print #File, !"\t!include WinMessages.nsh"
	Print #File, !"\t!include FileFunc.nsh"
	Print #File, !""
	Print #File, !";--------------------------------"
	Print #File, !";Include Modern UI"
	Print #File, !""
	Print #File, !"\t!include MUI2.nsh"
	Print #File, !""
	Print #File, !";--------------------------------"
	Print #File, !";Include Multi-User"
	Print #File, !""
	Print #File, !"\t;Default installation folder"
	Print #File, !"\t!define MULTIUSER_INSTALLMODE_INSTDIR ""${PRODUCT_INSTALL_DIR}"""
	Print #File, !""
	Print #File, !"\t;Get installation folder from registry if available"
	Print #File, !"\t!define MULTIUSER_INSTALLMODE_DEFAULT_REGISTRY_KEY ""Software\\${PRODUCT_REGISTRY_KEY}"""
	Print #File, !"\t!define MULTIUSER_INSTALLMODE_DEFAULT_REGISTRY_VALUENAME ""InstallDir"""
	Print #File, !"\t!define MULTIUSER_INSTALLMODE_INSTDIR_REGISTRY_KEY ""Software\\${PRODUCT_REGISTRY_KEY}"""
	Print #File, !"\t!define MULTIUSER_INSTALLMODE_INSTDIR_REGISTRY_VALUENAME ""InstallDir"""
	Print #File, !""
	If ProjectSettings.ExecLevel = PROJPUB_EXECLEVEL_ADMIN Then
		Print #File, !"\t!define MULTIUSER_EXECUTIONLEVEL Admin"
	ElseIf ProjectSettings.ExecLevel = PROJPUB_EXECLEVEL_POWERUSER Then
		Print #File, !"\t!define MULTIUSER_EXECUTIONLEVEL Power"
	ElseIf ProjectSettings.ExecLevel = PROJPUB_EXECLEVEL_HIGHEST Then
		Print #File, !"\t!define MULTIUSER_EXECUTIONLEVEL Highest"
	ElseIf ProjectSettings.ExecLevel = PROJPUB_EXECLEVEL_STANDARD Then
		Print #File, !"\t!define MULTIUSER_EXECUTIONLEVEL Standard"
	End If
	Print #File, !"\t!define MULTIUSER_MUI"
	Print #File, !"\t!define MULTIUSER_INSTALLMODE_COMMANDLINE"
	Print #File, !"\t!include MultiUser.nsh"
	Print #File, !""
	Print #File, !";--------------------------------"
	Print #File, !";General"
	Print #File, !""
	Print #File, !"\t;Name and file"
	Print #File, !"\tName ""${PRODUCT_NAME} ${PRODUCT_VERSION}"""
	Print #File, !"\tOutFile ""${PRODUCT_FILE}-${PRODUCT_VERSION}.exe"""
	Print #File, !""
	If (DisabledFeatures And PROJPUB_FEATURES_SHORTCUTS) = 0 And ProjectSettings.ShortcutOptions <> 0 Then
		Print #File, !";--------------------------------"
		Print #File, !";Variables"
		Print #File, !""
		Print #File, !"\tVar StartMenuFolder"
		Print #File, !""
	End If
	Print #File, !";--------------------------------"
	Print #File, !";Interface Configuration"
	Print #File, !""
	If ProjectSettings.IconInstall <> "" Then Print #File, !"\t!define MUI_ICON ""${PRODUCT_ICON}"""
	If ProjectSettings.IconUninstall <> "" Then Print #File, !"\t!define MUI_UNICON ""${PRODUCT_UNICON}"""
	If ProjectSettings.HeaderInstall <> "" Or ProjectSettings.HeaderUninstall <> "" Or ProjectSettings.HeaderInstallRight <> "" Or ProjectSettings.HeaderUninstallRight <> "" Then _
		Print #File, !"\t!define MUI_HEADERIMAGE"
	If ProjectSettings.HeaderInstall <> "" Then Print #File, !"\t!define MUI_HEADERIMAGE_BITMAP ""${PRODUCT_HEADERIMAGE_BITMAP}"""
	If ProjectSettings.HeaderUninstall <> "" Then Print #File, !"\t!define MUI_HEADERIMAGE_UNBITMAP ""${PRODUCT_HEADERIMAGE_UNBITMAP}"""
	If ProjectSettings.HeaderInstallRight <> "" Then Print #File, !"\t!define MUI_HEADERIMAGE_BITMAP_RTL ""${PRODUCT_HEADERIMAGE_BITMAP_RTL}"""
	If ProjectSettings.HeaderUninstallRight <> "" Then Print #File, !"\t!define MUI_HEADERIMAGE_UNBITMAP_RTL ""${PRODUCT_HEADERIMAGE_UNBITMAP_RTL}"""
	If (ProjectSettings.MuiOptions And PROJPUB_MUI_NOWELCOMEFINISHPAGE) = 0 Then
		If ProjectSettings.WizardInstall <> "" Then Print #File, !"\t!define MUI_WELCOMEFINISHPAGE_BITMAP ""${PRODUCT_WELCOMEFINISHPAGE_BITMAP}"""
		If ProjectSettings.WizardUninstall <> "" Then Print #File, !"\t!define MUI_UNWELCOMEFINISHPAGE_BITMAP ""${PRODUCT_UNWELCOMEFINISHPAGE_BITMAP}"""
	End If
	Print #File, !"\t!define MUI_ABORTWARNING"
	Print #File, !""
	Print #File, !";--------------------------------"
	Print #File, !";Language Selection Dialog Settings"
	Print #File, !""
	Print #File, !"\t;Remember the installer language"
	Print #File, !"\t!define MUI_LANGDLL_REGISTRY_ROOT ""SHCTX"""
	Print #File, !"\t!define MUI_LANGDLL_REGISTRY_KEY ""Software\\${PRODUCT_REGISTRY_KEY}"""
	Print #File, !"\t!define MUI_LANGDLL_REGISTRY_VALUENAME ""InstallLang"""
	Print #File, !""
	Print #File, !";--------------------------------"
	Print #File, !";Pages"
	Print #File, !""
	If (ProjectSettings.MuiOptions And PROJPUB_MUI_NOWELCOMEFINISHPAGE) = 0 Then
		Print #File, !"\t!define MUI_WELCOMEPAGE_TITLE_3LINES"
		Print #File, !"\t!insertmacro MUI_PAGE_WELCOME"
	End If
	If ProjectSettings.License <> "" Then _
		Print #File, !"\t!insertmacro MUI_PAGE_LICENSE ""${PRODUCT_LICENSE}"""
	Print #File, !"\t!insertmacro MULTIUSER_PAGE_INSTALLMODE"

	If ( _	' RemDrvInst is not disabled and the user didn't disabled it
			(DisabledFeatures And PROJPUB_FEATURES_REMDRVINST) = 0 And _
			ProjectSettings.RemDrvInst <> PROJPUB_REMDRVINST_DISABLE _
		) Or _
		( _	' File associations are not disabled and have entries
			(DisabledFeatures And PROJPUB_FEATURES_FILEASSOC) = 0 And _
			ProjectSettings.FileAssociations.Next <> NULL _
		) Then _
		Print #File, !"\t!insertmacro MUI_PAGE_COMPONENTS"

	Print #File, !"\t!insertmacro MUI_PAGE_DIRECTORY"
	Print #File, !""
	If (DisabledFeatures And PROJPUB_FEATURES_SHORTCUTS) = 0 And ProjectSettings.ShortcutOptions <> 0 Then
		Print #File, !"\t;Start Menu Folder Page Configuration"
		Print #File, !"\t!define MUI_STARTMENUPAGE_DEFAULTFOLDER ""${PRODUCT_NAME}"""
		Print #File, !"\t!define MUI_STARTMENUPAGE_REGISTRY_ROOT ""SHCTX"""
		Print #File, !"\t!define MUI_STARTMENUPAGE_REGISTRY_KEY ""Software\\${PRODUCT_REGISTRY_KEY}"""
		Print #File, !"\t!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME ""StartMenu"""
		Print #File, !""
	End If
	If (ProjectSettings.MuiOptions And PROJPUB_MUI_NOWELCOMEFINISHPAGE) = 0 Then
		Print #File, !"\t;Finish Page Configuration"
		If (ProjectSettings.RunOptions And PROJPUB_POSTOPTIONS_RUNENABLED) <> 0 And _
			(DisabledFeatures And PROJPUB_FEATURES_RUNONFINISH) = 0 Then
			If ProjectSettings.RunFunction <> "" Then
				Print #File, !"\t!define MUI_FINISHPAGE_RUN_FUNCTION """ & ProjectSettings.RunFunction & """"
			Else
				Print #File, !"\t!define MUI_FINISHPAGE_RUN """ & ProjectSettings.MainProgram & """"
				If ProjectSettings.RunParameters <> "" Then _
					Print #File, !"\t!define MUI_FINISHPAGE_RUN_PARAMETERS """ & ProjectSettings.RunParameters & """"
			End If
			Print #File, !"\t!define MUI_FINISHPAGE_RUN_TEXT """ & ProjectSettings.RunText & """"
			If (ProjectSettings.RunOptions And PROJPUB_POSTOPTIONS_RUNNOTCHECKED) <> 0 Then _
				Print #File, !"\t!define MUI_FINISHPAGE_RUN_NOTCHECKED"
		End If
		If (ProjectSettings.ShowReadmeOptions And PROJPUB_POSTOPTIONS_SHOWREADMEENABLED) <> 0 Then
			If ProjectSettings.ShowReadmeFunction <> "" Then
				Print #File, !"\t!define MUI_FINISHPAGE_SHOWREADME_FUNCTION """ & ProjectSettings.ShowReadmeFunction & """"
			Else
				Print #File, !"\t!define MUI_FINISHPAGE_SHOWREADME """ & ProjectSettings.ShowReadmeFileUrl & """"
			End If
			Print #File, !"\t!define MUI_FINISHPAGE_SHOWREADME_TEXT """ & ProjectSettings.ShowReadmeText & """"
			If (ProjectSettings.ShowReadmeOptions And PROJPUB_POSTOPTIONS_SHOWREADMENOTCHECKED) <> 0 Then _
				Print #File, !"\t!define MUI_FINISHPAGE_SHOWREADME_NOTCHECKED"
		End If
		If (ProjectSettings.WebsiteLinkOptions And PROJPUB_POSTOPTIONS_POSTWEBLINKENABLED) <> 0 And _
			ProjectSettings.ProjectLink <> "" Then
			Print #File, !"\t!define MUI_FINISHPAGE_LINK """ & ProjectSettings.WebsiteLinkText & """"
			Print #File, !"\t!define MUI_FINISHPAGE_LINK_LOCATION """ & ProjectSettings.ProjectLink & """"
		End If
		Print #File, !""
	End If
	If (DisabledFeatures And PROJPUB_FEATURES_REMDRVINST) = 0 Then _
		Print #File, !"\t!define MUI_PAGE_CUSTOMFUNCTION_PRE PreStartMenu"
	If (DisabledFeatures And PROJPUB_FEATURES_SHORTCUTS) = 0 And ProjectSettings.ShortcutOptions <> 0 Then _
		Print #File, !"\t!insertmacro MUI_PAGE_STARTMENU Application $StartMenuFolder"
	Print #File, !"\t!insertmacro MUI_PAGE_INSTFILES"
	If (ProjectSettings.MuiOptions And PROJPUB_MUI_NOWELCOMEFINISHPAGE) = 0 Then _
		Print #File, !"\t!insertmacro MUI_PAGE_FINISH"
	Print #File, !""
	If (ProjectSettings.MuiOptions And PROJPUB_MUI_NOWELCOMEFINISHPAGE) = 0 Then
		Print #File, !"\t!define MUI_WELCOMEPAGE_TITLE_3LINES"
		Print #File, !"\t!insertmacro MUI_UNPAGE_WELCOME"
	End If
	Print #File, !"\t!insertmacro MUI_UNPAGE_CONFIRM"
	Print #File, !"\t!insertmacro MUI_UNPAGE_INSTFILES"
	If (ProjectSettings.MuiOptions And PROJPUB_MUI_NOWELCOMEFINISHPAGE) = 0 Then _
		Print #File, !"\t!insertmacro MUI_UNPAGE_FINISH"
	Print #File, !""
	Print #File, !";--------------------------------"
	Print #File, !";Languages"
	Print #File, !""
	Print #File, !"\t;Insert each language here with !insertmacro MUI_LANGUAGE ""[LANGUAGE]"""
	Print #File, !""
	Print #File, !"\t!insertmacro MUI_LANGUAGE ""English"""

	CurLanguage = ProjectSettings.Languages.Next
	Do While CurLanguage <> NULL
		Print #File, !"\t!insertmacro MUI_LANGUAGE """ & *CurLanguage->Name & """"
		CurLanguage = CurLanguage->Next
	Loop

	Print #File, !""
	Print #File, !";--------------------------------"
	Print #File, !";Reserve Files"
	Print #File, !""
	Print #File, !"\t;If you are using solid compression, files that are required before"
	Print #File, !"\t;the actual installation should be stored first in the data block,"
	Print #File, !"\t;because this will make your installer start faster."
	Print #File, !""
	Print #File, !"\t!insertmacro MUI_RESERVEFILE_LANGDLL"
	Print #File, !""
	Print #File, !";--------------------------------"
	Print #File, !";Installer Metadata"
	Print #File, !""
	Print #File, !"\tVIAddVersionKey ""ProductName""\t\t""${PRODUCT_NAME}"""
	Print #File, !"\tVIAddVersionKey ""Comments""\t\t""${PRODUCT_NAME} ${PRODUCT_VERSION} Installer"""
	Print #File, !"\tVIAddVersionKey ""CompanyName""\t\t""${PRODUCT_AUTHOR}"""
	Print #File, !"\tVIAddVersionKey ""LegalCopyright""\t"" ${PRODUCT_AUTHOR}"""
	Print #File, !"\tVIAddVersionKey ""FileDescription""\t""${PRODUCT_NAME}"""
	Print #File, !"\tVIAddVersionKey ""FileVersion""\t\t""${PRODUCT_VERSION}"""
	Print #File, !"\tVIProductVersion ""${PRODUCT_VERSION}"""
	Print #File, !""
	Print #File, !";--------------------------------"
	Print #File, !";Installer Sections"
	Print #File, !""
	Print #File, !"Section"
	Print #File, !""

	CurFolder = (@ProjectSettings.Folders)->Next

	Do While CurFolder <> NULL

		CurFile = (@(CurFolder->File))->Next

		If CurFile Then

			Print #File, !"\tSetOutPath """ & *CurFolder->Name & """"
			Print #File, !""
		
			Do While CurFile <> NULL
				Print #File, !"\tFile """ & *CurFile->Name & """"
				CurFile = CurFile->Next
			Loop

			Print #File, !""

		End If

		CurFolder = CurFolder->Next

	Loop

	Print #File, !"\t;Create uninstaller"
	Print #File, !"\tWriteUninstaller ""$INSTDIR\\" & ProjectSettings.Uninstaller & """"
	Print #File, !""
	Print #File, !"\tCall InstallNonRemDriveItems"
	Print #File, !""
	Print #File, !"SectionEnd"
	Print #File, !""

	If (DisabledFeatures And PROJPUB_FEATURES_FILEASSOC) = 0 Then

		CurFileType = (@ProjectSettings.FileAssociations)->Next
	
		If CurFileType <> NULL Then
		Print #File, !";--------------------------------"
		Print #File, !";File Association Sections"
		Print #File, !""
			Print #File, !"SectionGroup ""$(NAME_SecFileAssoc)"" SecFileAssoc"
			Print #File, !""
			Do While CurFileType <> NULL
				Dim CurContextMenu As ProjPub_FileTypeContextMenu Ptr = (@(CurFileType->ContextMenu))->Next
				Print #File, !"\tSection """ & *CurFileType->Description & """ SecFileAssoc" & FilterNSISIdentifier( *CurFileType->AppIDKey )
				Print #1, !""
				Print #1, !"\t\tWriteRegStr SHCTX ""Software\\Classes\\" & *CurFileType->Ext & """ """" """ & *CurFileType->AppIDKey & """"
				Print #1, !"\t\tWriteRegStr SHCTX ""Software\\Classes\\" & *CurFileType->AppIDKey & """ """" """ & *CurFileType->Description & """"
				If *CurFileType->Description <> "" Then _
					Print #1, !"\t\tWriteRegStr SHCTX ""Software\\Classes\\" & *CurFileType->AppIDKey & "\DefaultIcon"" """" """ & *CurFileType->DefaultIcon & """"
				Do While CurContextMenu <> NULL
					If *CurContextMenu->ItemText <> "" Then Print #1, !"\t\tWriteRegStr SHCTX ""Software\\Classes\\" & *CurFileType->AppIDKey & "\shell\" & *CurContextMenu->Verb & """ """" """ & *CurContextMenu->ItemText & """"
					Print #1, !"\t\tWriteRegStr SHCTX ""Software\\Classes\\" & *CurFileType->AppIDKey & "\shell\" & *CurContextMenu->Verb & "\command"" """" """ & EscapeNSIS( *CurContextMenu->Command ) & """"
					CurContextMenu = CurContextMenu->Next
				Loop
				Print #File, !""
				Print #File, !"\t\t${RefreshShellIcons}"
				Print #File, !""
				Print #File, !"\tSectionEnd"
				Print #File, !""
				CurFileType = CurFileType->Next
			Loop
			Print #File, !"SectionGroupEnd"
		End If

	End If

	If (DisabledFeatures And PROJPUB_FEATURES_REMDRVINST) = 0 Then
		Print #File, !"Section /o ""$(NAME_SecRemDriveInstall)"" SecRemDriveInstall"
		Print #File, !""
		Print #File, !"SectionEnd"
		Print #File, !""
	End If

	If ( _	' RemDrvInst is not disabled and the user didn't disabled it
			(DisabledFeatures And PROJPUB_FEATURES_REMDRVINST) = 0 And _
			ProjectSettings.RemDrvInst <> PROJPUB_REMDRVINST_DISABLE _
		) Or _
		( _	' File associations are not disabled and have entries
			(DisabledFeatures And PROJPUB_FEATURES_FILEASSOC) = 0 And _
			ProjectSettings.FileAssociations.Next <> NULL _
		) Then

		Print #File, !";--------------------------------"
		Print #File, !";Descriptions"
		Print #File, !""
		Print #File, !"\t;Language strings"

		If (DisabledFeatures And PROJPUB_FEATURES_REMDRVINST) = 0 Then _
			Print #File, !"\tLangString NAME_SecRemDriveInstall\t\t\t${LANG_ENGLISH}\t\t""Install In Removable Drive"""
			Print #File, !"\tLangString DESC_SecRemDriveInstall\t\t\t${LANG_ENGLISH}\t\t""This will disallow installation of registry entries and Start Menu items for installing in removable drives."""
			CurLanguage = ProjectSettings.Languages.Next
			Do While CurLanguage <> NULL
				Print #File, !"\tLangString NAME_SecRemDriveInstall\t\t\t${" & GetLanguageDefine( *CurLanguage->Name ) & !"}\t\t""" & GetLanguageString( *CurLanguage->Name, 1, "Install In Removable Drive" ) & """"
				Print #File, !"\tLangString DESC_SecRemDriveInstall\t\t\t${" & GetLanguageDefine( *CurLanguage->Name ) & !"}\t\t""" & GetLanguageString( *CurLanguage->Name, 2, "This will disallow installation of registry entries and Start Menu items for installing in removable drives." ) & """"
				CurLanguage = CurLanguage->Next
			Loop

		If (DisabledFeatures And PROJPUB_FEATURES_FILEASSOC) = 0 Then
			CurFileType = (@ProjectSettings.FileAssociations)->Next
			If CurFileType <> NULL Then
				Print #File, !"\tLangString NAME_SecFileAssoc\t\t\t\t${LANG_ENGLISH}\t\t""File Associations"""
				Print #File, !"\tLangString DESC_SecFileAssoc\t\t\t\t${LANG_ENGLISH}\t\t""Associate ${PRODUCT_NAME} with files."""
				CurLanguage = ProjectSettings.Languages.Next
				Do While CurLanguage <> NULL
					Print #File, !"\tLangString NAME_SecFileAssoc\t\t\t\t${" & GetLanguageDefine( *CurLanguage->Name ) & !"}\t\t""" & GetLanguageString( *CurLanguage->Name, 3, "File Associations" ) & """"
					Print #File, !"\tLangString DESC_SecFileAssoc\t\t\t\t${" & GetLanguageDefine( *CurLanguage->Name ) & !"}\t\t""" & GetLanguageString( *CurLanguage->Name, 4, "Associate ${PRODUCT_NAME} with files." ) & """"
					CurLanguage = CurLanguage->Next
				Loop
				Do While CurFileType <> NULL
					Print #File, !"\tLangString DESC_SecFileAssoc" & FilterNSISIdentifier( *CurFileType->AppIDKey ) & !"\t\t${LANG_ENGLISH}\t\t""" & EscapeNSIS( *CurFileType->Description ) & """"
					CurLanguage = ProjectSettings.Languages.Next
					Do While CurLanguage <> NULL
						Print #File, !"\tLangString DESC_SecFileAssoc" & FilterNSISIdentifier( *CurFileType->AppIDKey ) & !"\t\t${" & GetLanguageDefine( *CurLanguage->Name ) & "}\t\t""" & EscapeNSIS( *CurFileType->Description ) & """"
						CurLanguage = CurLanguage->Next
					Loop
					CurFileType = CurFileType->Next
				Loop
			End If
		End If

		If ( _	' RemDrvInst is not disabled and the user didn't disabled it
				(DisabledFeatures And PROJPUB_FEATURES_REMDRVINST) = 0 And _
				ProjectSettings.RemDrvInst <> PROJPUB_REMDRVINST_DISABLE _
			) Or _
			( _	' File associations are not disabled and have entries
				(DisabledFeatures And PROJPUB_FEATURES_FILEASSOC) = 0 And _
				ProjectSettings.FileAssociations.Next <> NULL _
			) Then

			Print #File, !""
			Print #File, !"\t;Assign language strings to sections"
			Print #File, !"\t!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN"

			If (DisabledFeatures And PROJPUB_FEATURES_REMDRVINST) = 0 Then _
				Print #File, !"\t!insertmacro MUI_DESCRIPTION_TEXT ${SecRemDriveInstall}\t\t\t$(DESC_SecRemDriveInstall)"
	
			If (DisabledFeatures And PROJPUB_FEATURES_FILEASSOC) = 0 Then
				CurFileType = (@ProjectSettings.FileAssociations)->Next
				If CurFileType <> NULL Then
					Print #File, !"\t!insertmacro MUI_DESCRIPTION_TEXT ${SecFileAssoc}\t\t\t\t$(DESC_SecFileAssoc)"
					Do While CurFileType <> NULL
						Print #File, !"\t!insertmacro MUI_DESCRIPTION_TEXT ${SecFileAssoc" & FilterNSISIdentifier( *CurFileType->AppIDKey ) & !"}\t\t\t$(DESC_SecFileAssoc" & FilterNSISIdentifier( *CurFileType->AppIDKey ) & ")"
						CurFileType = CurFileType->Next
					Loop
				End If
			End If

			Print #File, !"\t!insertmacro MUI_FUNCTION_DESCRIPTION_END"
			Print #File, !""
	
		End If

	End If

	Print #File, !";--------------------------------"
	Print #File, !";Uninstaller Section"
	Print #File, !""
	Print #File, !"Section ""Uninstall"""
	Print #File, !""
/'	Print #File, !"\tClearErrors"
	Print #File, !"\t;Open uninstall.ini"
	Print #File, !"\tFileOpen $0 ""$INSTDIR\\uninstall.ini"" r"
	Print #File, !"\t${IfNot} ${Errors}"
	Print #File, !"\t\t;Set current dir for searching uninstallers"
	Print #File, !"\t\tStrCpy $3 $OUTDIR"
	Print #File, !"\t\tSetOutPath $INSTDIR"
	Print #File, !"\t\t${Do}"
	Print #File, !"\t\t\t;Get one line"
	Print #File, !"\t\t\tFileRead $0 $1"
	Print #File, !"\t\t\t${If} $1 != """""
	Print #File, !"\t\t\t\t;Check if relative"
	Print #File, !"\t\t\t\tSearchPath $2 $1"
	Print #File, !"\t\t\t\t${If} $2 != """""
	Print #File, !"\t\t\t\t\t;Copy to $1 if relative and valid"
	Print #File, !"\t\t\t\t\tStrCpy $1 $2"
	Print #File, !"\t\t\t\t${EndIf}"
	Print #File, !"\t\t\t\t${If} ${FileExists} $1"
	Print #File, !"\t\t\t\t\tCopyFiles $1 $TEMP"
	Print #File, !"\t\t\t\t\t;Get parent dir, passed as $INSTDIR"
	Print #File, !"\t\t\t\t\t${GetParent} $1 $2"
	Print #File, !"\t\t\t\t\t${GetFileName} $1 $1"
	Print #File, !"\t\t\t\t\t;Execute as silent and set $INSTDIR"
	Print #File, !"\t\t\t\t\tExecWait '""$TEMP\\$1"" /S _?=$2'"
	Print #File, !"\t\t\t\t\tDelete ""$TEMP\\$1"""
	Print #File, !"\t\t\t\t${EndIf}"
	Print #File, !"\t\t\t${Else}"
	Print #File, !"\t\t\t\t${ExitDo}"
	Print #File, !"\t\t\t${EndIf}"
	Print #File, !"\t\t${Loop}"
	Print #File, !"\t\t;Close uninstall.ini"
	Print #File, !"\t\tFileClose $0"
	Print #File, !"\t\t;Set to previous value"
	Print #File, !"\t\tSetOutPath $3"
	Print #File, !"\t${EndIf}"
	Print #File, !""
'/
	Print #File, !"\tDelete ""$INSTDIR\\" & ProjectSettings.Uninstaller & """"
	If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_PRJWEBSITE) = PROJPUB_SHORTCUT_PRJWEBSITE Then _
		Print #File, !"\tDelete ""$INSTDIR\\Website.url"""

	CurFolder = (@ProjectSettings.Folders)->Next

	Do While CurFolder <> NULL
		CurFile = (@(CurFolder->File))->Next
		Do While CurFile <> NULL
			Print #File, !"\tDelete """ & *CurFolder->Name & "\" & GetFileName( *CurFile->Name ) & """"
			CurFile = CurFile->Next
		Loop
		CurFolder = CurFolder->Next
	Loop
	Print #File, !""

	Dim FoldersNum As Integer = GetFoldersNum( @ProjectSettings.Folders )

	If FoldersNum Then

		Dim RemoveFolders( 0 To FoldersNum-1 ) As String

		CurFolder = (@ProjectSettings.Folders)->Next

		For i As Integer = 0 To FoldersNum-1
			RemoveFolders(i) = *CurFolder->Name
			CurFolder = CurFolder->Next
		Next

		For i As Integer = FoldersNum-1 To 0 Step -1
			Print #File, !"\tRMDir """ & RemoveFolders(i) & """"
		Next

		Print #File, !""

	End If

	Print #File, !"\tReadRegStr $0 SHCTX ""Software\\${PRODUCT_REGISTRY_KEY}"" ""InstallDir"""
	Print #File, !""
	Print #File, !"\t${If} $0 == $INSTDIR"
	If (DisabledFeatures And PROJPUB_FEATURES_SHORTCUTS) = 0 And ProjectSettings.ShortcutOptions <> 0 Then
		Print #File, !"\t\t!insertmacro MUI_STARTMENU_GETFOLDER Application $StartMenuFolder"
		Print #File, !""
		If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_MAINPROGRAM) = PROJPUB_SHORTCUT_MAINPROGRAM Then _
			Print #File, !"\t\tDelete ""$SMPROGRAMS\\$StartMenuFolder\\${PRODUCT_NAME}.lnk"""
		If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_PRJWEBSITE) = PROJPUB_SHORTCUT_PRJWEBSITE Then _
			Print #File, !"\t\tDelete ""$SMPROGRAMS\\$StartMenuFolder\\Website.lnk"""
	'	Print #File, !"\t\tDelete ""$SMPROGRAMS\\$StartMenuFolder\\Forum.lnk"""
		If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_UNINSTALLER) = PROJPUB_SHORTCUT_UNINSTALLER Then _
			Print #File, !"\t\tDelete ""$SMPROGRAMS\\$StartMenuFolder\\Uninstall.lnk"""
		If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_MAININDESKTOP) = PROJPUB_SHORTCUT_MAININDESKTOP Then _
			Print #File, !"\t\tDelete ""$DESKTOP\\${PRODUCT_NAME}.lnk"""
		Print #File, !""
		Print #File, !"\t\tRMDir ""$SMPROGRAMS\\$StartMenuFolder"""
		Print #File, !""
	End If
	Print #File, !"\t\tDeleteRegKey /ifempty SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"""
	Print #File, !"\t\tDeleteRegKey /ifempty SHCTX ""Software\\${PRODUCT_REGISTRY_KEY}"""
	If (DisabledFeatures And PROJPUB_FEATURES_OPENWITH) = 0 And ProjectSettings.OpenWithCommand <> "" Then _
		Print #File, !"\t\tDeleteRegKey SHCTX ""Software\\Classes\\Applications\\" & GetFileName( ProjectSettings.MainProgram ) & !""""
	If (DisabledFeatures And PROJPUB_FEATURES_FILEASSOC) = 0 Then
		CurFileType = (@ProjectSettings.FileAssociations)->Next
		If CurFileType <> NULL Then
			Print #File, !""
			Do While CurFileType <> NULL
				Print #File, !"\t\tDeleteRegKey SHCTX ""Software\\Classes\\" & *CurFileType->Ext & """"
				Print #File, !"\t\tDeleteRegKey SHCTX ""Software\\Classes\\" & *CurFileType->AppIDKey & """"
				CurFileType = CurFileType->Next
			Loop
			Print #File, !"\t\t${RefreshShellIcons}"
		End If
	End If
	Print #File, !"\t${EndIf}"
	Print #File, !""
	Print #File, !"SectionEnd"
	Print #File, !""
	If (DisabledFeatures And PROJPUB_FEATURES_REMDRVINST) = 0 Then
		Print #File, !";--------------------------------"
		Print #File, !";This will skip installing Start Menu items if installing"
		Print #File, !";into removable drives"
		Print #File, !""
		Print #File, !"Function PreStartMenu"
		Print #File, !""
		Print #File, !"\t${If} ${SectionIsSelected} ${SecRemDriveInstall}"
		Print #File, !"\t\tAbort"
		Print #File, !"\t${EndIf}"
		Print #File, !""
		Print #File, !"FunctionEnd"
		Print #File, !""
	End If
	Print #File, !";--------------------------------"
	Print #File, !";This will install the registry entries and start menu"
	Print #File, !";items if not installing into removable drives"
	Print #File, !""
	Print #File, !"Function InstallNonRemDriveItems"
	Print #File, !""
	If (DisabledFeatures And PROJPUB_FEATURES_REMDRVINST) = 0 Then _
		Print #File, !"\t${IfNot} ${SectionIsSelected} ${SecRemDriveInstall}"
	Print #File, !""
	If (DisabledFeatures And PROJPUB_FEATURES_SHORTCUTS) = 0 And ProjectSettings.ShortcutOptions <> 0 Then
		Print #File, !"\t\t!insertmacro MUI_STARTMENU_WRITE_BEGIN Application"
		Print #File, !""
		Print #File, !"\t\t\t;Create shortcuts"
		Print #File, !"\t\t\tCreateDirectory ""$SMPROGRAMS\\$StartMenuFolder"""
		If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_PRJWEBSITE) = PROJPUB_SHORTCUT_PRJWEBSITE Then _
			Print #File, !"\t\t\tWriteIniStr ""$INSTDIR\\Website.url"" ""InternetShortcut"" ""URL"" ""${PRODUCT_WEB_SITE}"""
	'	Print #File, !"\t\t\tWriteIniStr ""$INSTDIR\\Forum.url"" ""InternetShortcut"" ""URL"" ""${PRODUCT_WEB_FORUM}"""
		If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_MAINPROGRAM) = PROJPUB_SHORTCUT_MAINPROGRAM Then _
			Print #File, !"\t\t\tCreateShortCut ""$SMPROGRAMS\\$StartMenuFolder\\${PRODUCT_NAME}.lnk"" """ & ProjectSettings.MainProgram & """"
		If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_PRJWEBSITE) = PROJPUB_SHORTCUT_PRJWEBSITE Then _
			Print #File, !"\t\t\tCreateShortCut ""$SMPROGRAMS\\$StartMenuFolder\\Website.lnk"" ""$INSTDIR\\Website.url"""
	'	Print #File, !"\t\t\tCreateShortCut ""$SMPROGRAMS\\$StartMenuFolder\\Forum.lnk"" ""$INSTDIR\\Forum.url"""
		If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_UNINSTALLER) = PROJPUB_SHORTCUT_UNINSTALLER Then _
			Print #File, !"\t\t\tCreateShortCut ""$SMPROGRAMS\\$StartMenuFolder\\Uninstall.lnk"" ""$INSTDIR\\" & ProjectSettings.Uninstaller & """"
		If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_MAININDESKTOP) = PROJPUB_SHORTCUT_MAININDESKTOP Then _
			Print #File, !"\t\t\tCreateShortCut ""$DESKTOP\\${PRODUCT_NAME}.lnk"" """ & ProjectSettings.MainProgram & """"
		Print #File, !""
		Print #File, !"\t\t!insertmacro MUI_STARTMENU_WRITE_END"
		Print #File, !""
	End If
	Print #File, !"\t\t;Store installation folder"
	Print #File, !"\t\tWriteRegStr SHCTX ""Software\\${PRODUCT_REGISTRY_KEY}"" ""InstallDir"" ""$INSTDIR"""
	Print #File, !""
	If (DisabledFeatures And PROJPUB_FEATURES_OPENWITH) = 0 And ProjectSettings.OpenWithCommand <> "" Then
		Print #File, !"\t\t;Add to Open With dialog box"
		Print #File, !"\t\tWriteRegStr SHCTX ""Software\\Classes\\Applications\\" & GetFileName( ProjectSettings.MainProgram ) & !"\\shell\\open\\command"" """" """ & EscapeNSIS( ProjectSettings.OpenWithCommand ) & """"
		Print #File, !""
	End If
	Print #File, !"\t\tWriteRegStr SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""DisplayName"" ""${PRODUCT_NAME}"""
	Print #File, !"\t\tWriteRegStr SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""DisplayVersion"" ""${PRODUCT_DISPLAY_VERSION}"""
	Print #File, !"\t\tWriteRegStr SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""UninstallString"" ""$\\""$INSTDIR\\" & ProjectSettings.Uninstaller & !"$\\"""""
	Print #File, !"\t\tWriteRegStr SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""InstallLocation"" ""$\\""$INSTDIR$\\"""""
	Print #File, !"\t\tWriteRegStr SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""DisplayIcon"" ""$\\""$INSTDIR\\" & ProjectSettings.Uninstaller & !"$\\"""""
	Print #File, !"\t\tWriteRegStr SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""Publisher"" ""${PRODUCT_AUTHOR}"""
'	Print #File, !";\t\tWriteRegStr SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""ModifyPath"" """""
	Print #File, !";\t\tWriteRegStr SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""InstallSource"" """""
'	Print #File, !";\t\tWriteRegStr SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""ProductID"" """""
'	Print #File, !";\t\tWriteRegStr SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""RegOwner"" """""
'	Print #File, !";\t\tWriteRegStr SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""RegCompany"" """""
	If ProjectSettings.SupportLink <> "" Then Print #File, !"\t\tWriteRegStr SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""HelpLink"" ""${PRODUCT_WEB_FORUM}"""
'	Print #File, !";\t\tWriteRegStr SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""HelpTelephone"" """""
	If ProjectSettings.UpdateLink <> "" Then Print #File, !"\t\tWriteRegStr SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""URLUpdateInfo"" ""${PRODUCT_WEB_UPDATE}"""
	If ProjectSettings.ProjectLink <> "" Then Print #File, !"\t\tWriteRegStr SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""URLInfoAbout"" ""${PRODUCT_WEB_SITE}"""
	Print #File, !"\t\tWriteRegStr SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""DisplayVersion"" ""${PRODUCT_VERSION}"""
	Print #File, !"\t\tWriteRegDWORD SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""VersionMajor"" ${PRODUCT_VERSION_MAJOR}"
	Print #File, !"\t\tWriteRegDWORD SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""VersionMinor"" ${PRODUCT_VERSION_MINOR}"
	Print #File, !"\t\tWriteRegDWORD SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""NoModify (DWORD)"" 0x1"
	Print #File, !"\t\tWriteRegDWORD SHCTX ""Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\${PRODUCT_REGISTRY_KEY}"" ""NoRepair (DWORD)"" 0x1"
	Print #File, !""
	If (DisabledFeatures And PROJPUB_FEATURES_REMDRVINST) = 0 Then _
		Print #File, !"\t${EndIf}"
	Print #File, !""
	Print #File, !"FunctionEnd"
	Print #File, !""
	Print #File, !";--------------------------------"
	Print #File, !";Installer Functions"
	Print #File, !""
	Print #File, !"Function .onInit"
	Print #File, !""
	Print #File, !"\t!insertmacro MULTIUSER_INIT"
	Print #File, !""
	Print #File, !"\t!insertmacro MUI_LANGDLL_DISPLAY"
	Print #File, !""
	Print #File, !"FunctionEnd"
	Print #File, !""
	If ProjectSettings.RequireInstallFolder <> "" Then
		Print #File, !"Function .onVerifyInstDir"
		Print #File, !""
		Print #File, !"	; if $INSTDIR don't have " & ProjectSettings.RequireInstallFolder & ", don't let us install there"
		Print #File, !"	${IfNot} ${FileExists} ""$INSTDIR\\" & ProjectSettings.RequireInstallFolder & """"
		Print #File, !"		Abort"
		Print #File, !"	${EndIf}"
		Print #File, !""
		Print #File, !"FunctionEnd"
		Print #File, !""
	End If
	Print #File, !";--------------------------------"
	Print #File, !";Uninstaller Functions"
	Print #File, !""
	Print #File, !"Function un.onInit"
	Print #File, !""
	Print #File, !"\t!insertmacro MULTIUSER_UNINIT"
	Print #File, !""
	Print #File, !"\t!insertmacro MUI_UNGETLANGUAGE"
	Print #File, !""

	/'
	Dim UpsFromUninstall As Integer = GetUpFromParentDir( ProjectSettings.Uninstaller )
	If UpsFromUninstall Then
		Print #File, !"\t${IfNot} ""$INSTDIR\\" & ProjectSettings.Uninstaller & !""" == ""$EXEPATH"""
		Print #File, !"\t\t; Go to $INSTDIR"
		For i As Integer = 1 To UpsFromUninstall
			Print #File, !"\t\t${GetParent} $INSTDIR $INSTDIR"
		Next
		Print #File, !"\t${EndIf}"
		Print #File, !""
	End If
	'/

	Print #File, !"FunctionEnd"
	Print #File, !""

	Close #File

	Return 0

End Function

