Type ProjPub_Settings
	NSISPath As ZString * MAX_PATH+1
	Author As ZString * MAX_PATH+1
	WizardInstall As ZString * MAX_PATH+1
	WizardUninstall As ZString * MAX_PATH+1
	HeaderInstall As ZString * MAX_PATH+1
	HeaderInstallRight As ZString * MAX_PATH+1
	HeaderUninstall As ZString * MAX_PATH+1
	HeaderUninstallRight As ZString * MAX_PATH+1
	IconInstall As ZString * MAX_PATH+1
	IconUninstall As ZString * MAX_PATH+1
	RunInstallerDefault As Byte
	ShowCompressorPage As Byte
	EditOptionsDefault As Byte
End Type

#Define MAX_PROJSETTINGS_NAME						50
#Define MAX_PROJSETTINGS_VERSION					20
#Define MAX_PROJSETTINGS_AUTHOR					50
#Define MAX_PROJSETTINGS_SHORTNAME				15
#Define MAX_PROJSETTINGS_PROJLINK				64
#Define MAX_PROJSETTINGS_SUPPLINK				64
#Define MAX_PROJSETTINGS_UPDATELINK				64
#Define MAX_PROJSETTINGS_INSTFOLDER				32
#Define MAX_PROJSETTINGS_RUNTEXT					32
#Define MAX_PROJSETTINGS_RUNPARAMS				32
#Define MAX_PROJSETTINGS_RUNFUNCTION			32
#Define MAX_PROJSETTINGS_SHOWREADMETEXT		32
#Define MAX_PROJSETTINGS_SHOWREADMEFUNCTION	32
#Define MAX_PROJSETTINGS_POSTWEBLINK			32

Type ProjPub_ProjSettings
	ProjectType As Integer
	Name As ZString * MAX_PROJSETTINGS_NAME+1
	Version As ZString * MAX_PROJSETTINGS_VERSION+1
	VersionMajor As Integer
	VersionMinor As Integer
	VersionBuild As Integer
	VersionRevision As Integer
	Author As ZString * MAX_PROJSETTINGS_AUTHOR+1
	ShortName As ZString * MAX_PROJSETTINGS_SHORTNAME+1
	ProjectLink As ZString * MAX_PROJSETTINGS_PROJLINK+1
	SupportLink As ZString * MAX_PROJSETTINGS_SUPPLINK+1
	UpdateLink As ZString * MAX_PROJSETTINGS_UPDATELINK+1
	License As ZString * MAX_PATH+1
	ExecLevel As Integer
	InstallFolder As ZString * MAX_PROJSETTINGS_INSTFOLDER+1
	RequireInstallFolder As ZString * MAX_PATH+1
	Folders As ProjPub_Folder
	MuiOptions As Integer
	WizardInstall As ZString * MAX_PATH+1
	WizardUninstall As ZString * MAX_PATH+1
	HeaderInstall As ZString * MAX_PATH+1
	HeaderInstallRight As ZString * MAX_PATH+1
	HeaderUninstall As ZString * MAX_PATH+1
	HeaderUninstallRight As ZString * MAX_PATH+1
	IconInstall As ZString * MAX_PATH+1
	IconUninstall As ZString * MAX_PATH+1
	RemDrvInst As Integer
	RemDrvInstUninst As Integer
	StartMenuFolder As ZString * MAX_PATH+1
	MainProgram As ZString * MAX_PATH+1
	ShortcutOptions As Integer
	FileAssociations As ProjPub_FileType
	Uninstaller As ZString * MAX_PATH+1
	Compressor As Integer
	CompressorOptions As Integer
	OpenWithCommand As ZString * MAX_PATH+1
	Languages As ProjPub_Lang
	RunOptions As Integer
	RunText As ZString * MAX_PROJSETTINGS_RUNTEXT+1
	RunParameters As ZString * MAX_PROJSETTINGS_RUNPARAMS+1
	RunFunction As ZString * MAX_PROJSETTINGS_RUNFUNCTION+1
	ShowReadmeOptions As Integer
	ShowReadmeText As ZString * MAX_PROJSETTINGS_SHOWREADMETEXT+1
	ShowReadmeFileUrl As ZString * MAX_PATH+1
	ShowReadmeFunction As ZString * MAX_PROJSETTINGS_SHOWREADMEFUNCTION+1
	WebsiteLinkOptions As Integer
	WebsiteLinkText As ZString * MAX_PROJSETTINGS_POSTWEBLINK+1
End Type

Common Shared GlobalSettings As ProjPub_Settings
Common Shared ProjectSettings As ProjPub_ProjSettings

Declare Function SettingsDialogProc( ByVal hWin As HWND, ByVal uMsg As UINT, ByVal wParam As WPARAM, ByVal lParam As LPARAM ) As BOOL
Declare Sub SaveSettingsIni( ByVal SettingsFile As ZString Ptr )
Declare Sub LoadSettingsIni( ByVal SettingsFile As ZString Ptr )
Declare Sub SaveSettingsRegistry( ByVal hKey As HKEY, ByVal lpSubKey As ZString Ptr )
Declare Sub LoadSettingsRegistry( ByVal hKey As HKEY, ByVal lpSubKey As ZString Ptr )
Declare Sub SaveProjectSettings( ByVal ProjectFile As ZString Ptr )
Declare Sub LoadProjectSettings( ByVal ProjectFile As ZString Ptr )
