/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEd
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 ' As a special exception, Arnel A. Borja gives unlimited permission to copy, 
 ' distribute and modify the files that are the output of this program, and to 
 ' copy and distribute the resulting files under terms of your choice.  You need 
 ' not follow the terms of the GNU General Public License when using or 
 ' distributing such files, even though portions of the text of the program 
 ' appear in them.  The GNU General Public License (GPL) does govern all other 
 ' use of the material that constitutes the program.
 '
 ' This special exception to the GPL applies to versions of the program released 
 ' by Arnel A. Borja.  When you make and distribute a modified version of the 
 ' program, you may extend this special exception to the GPL to apply to your 
 ' modified version as well.
 '
 '/


#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/commdlg.bi"
#Include Once "win/shellapi.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "Wizard.bi"
#Include Once "Settings.bi"
#Include Once "Welcome.bi"
#Include Once "Recompile.bi"
#Include Once "ProjType.bi"
#Include Once "ProjInfo.bi"
#Include Once "ProjWeb.bi"
#Include Once "License.bi"
#Include Once "MultiUser.bi"
#Include Once "InstallFolder.bi"
#Include Once "Files.bi"
#Include Once "Mui.bi"
#Include Once "RemDrvInst.bi"
#Include Once "Shortcuts.bi"
#Include Once "LangDll.bi"
#Include Once "FileAssoc.bi"
#Include Once "OpenWith.bi"
#Include Once "Uninst.bi"
#Include Once "Compressor.bi"
#Include Once "PostOptions.bi"
#Include Once "Preview.bi"
#Include Once "Publish.bi"
#Include Once "Finish.bi"
#Include Once "Failed.bi"
#Include Once "Resource.bi"


Declare Function PublishProjectWizardCallback ( ByVal hwndDlg As HWND, ByVal uMsg As UINT, ByVal lParam As LPARAM ) As Integer


' This will show the Publish Project Wizard
Sub ShowPublishProjectWizard ( _
	ByVal hwndOwner As HWND _
	)

   Dim As PROPSHEETPAGE psp(0 To PROJPUB_WIZPAGES_END)
   Dim As PROPSHEETHEADER psh

   With psp(PROJPUB_WIZPAGE_WELCOME)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGWELCOME)
		.pfnDlgProc				= @WelcomeDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_RECOMPILE)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGRECOMPILE)
		.pfnDlgProc				= @RecompileDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_PROJTYPE)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGPROJTYPE)
		.pfnDlgProc				= @ProjTypeDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_PROJINFO)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGPROJINFO)
		.pfnDlgProc				= @ProjInfoDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_PROJWEB)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGPROJWEB)
		.pfnDlgProc				= @ProjWebDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_LICENSE)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGLICENSE)
		.pfnDlgProc				= @LicenseDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_MULTIUSER)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGMULTIUSER)
		.pfnDlgProc				= @MultiUserDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_INSTALLFOLDER)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGINSTFOLDER)
		.pfnDlgProc				= @InstallFolderDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_FILES)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGFILES)
		.pfnDlgProc				= @FilesDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_MUI)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGMUI)
		.pfnDlgProc				= @MuiDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_REMDRVINST)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGREMDRVINST)
		.pfnDlgProc				= @RemDrvInstDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_SHORTCUTS)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGSHORTCUTS)
		.pfnDlgProc				= @ShortcutsDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_LANGDLL)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGLANGDLL)
		.pfnDlgProc				= @LangDllDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_FILEASSOC)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGFILEASSOC)
		.pfnDlgProc				= @FileAssocDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_OPENWITH)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGOPENWITH)
		.pfnDlgProc				= @OpenWithDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_UNINST)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGUNINST)
		.pfnDlgProc				= @UninstDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_COMPRESSOR)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGCOMPRESSOR)
		.pfnDlgProc				= @CompressorDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_POSTOPTIONS)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGPOSTOPTIONS)
		.pfnDlgProc				= @PostOptionsDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_PREVIEW)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGPREVIEW)
		.pfnDlgProc				= @PreviewDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_PUBLISH)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGPUBLISH)
		.pfnDlgProc				= @PublishDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_FINISH)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGFINISH)
		.pfnDlgProc				= @FinishDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_FAILED)
		.dwSize					= SizeOf( PROPSHEETPAGE )
		.hInstance				= hInstance
		.pszTemplate			= MAKEINTRESOURCE(IDD_DLGFAILED)
		.pfnDlgProc				= @FailedDialogProc
   End With

	' Wizard caption
	buffer = GetTranslateString( "6000", "Publish Project Wizard" )

	With psh
		.dwSize					= SizeOf( PROPSHEETHEADER )
		.dwFlags					= PSH_USEICONID Or PSH_PROPSHEETPAGE Or PSH_WIZARD
		#Ifndef NOHTMLHELP
		.dwFlags 				Or= PSH_USECALLBACK
		#EndIf
		.hwndParent				= hwndOwner
		.hInstance				= hInstance
		.pszIcon					= MAKEINTRESOURCE(IDI_PROJPUB)
		.pszCaption				= @buffer
		.nPages					= PROJPUB_WIZPAGES
		.nStartPage				= 0
		.ppsp						= Cast( LPCPROPSHEETPAGE, @psp(0) )
		#Ifndef NOHTMLHELP
		.pfnCallback			= @PublishProjectWizardCallback
		#EndIf
	End With

	PropertySheet( @psh )

End Sub


#Ifndef NOHTMLHELP

Function PublishProjectWizardCallback ( _
	ByVal hwndDlg As HWND, _
	ByVal uMsg As UINT, _
	ByVal lParam As LPARAM _
	) As Integer

	Select Case uMsg
		Case PSCB_PRECREATE
			Cast( DLGTEMPLATE Ptr, lParam )->style Or= DS_CONTEXTHELP
			'
	End Select

	Return 0

End Function

#EndIf

